      subroutine RESPON(iflag,nf,f0,df,amp,phas,
     * hds_nzer,hds_npol,hds_amp1,hds_zer,hds_pol) 


c********************************************************************** 
c     to calculate amplitude and phase frequency response of 
c     analog (pendulum-galvanometer) and electronic seismometers 
c     for given type- (iflag), initial frequency (in Hz)-(f0), 
c     frequency increment (in Hz) -(df) and number of frequencies. 
c     These parameters should be read from the screen. 
c     To stop the programm type iflag value 0 and arbitrary 
c     other values 
c---------------Types of instruments----------------------------------- 
c    The possible types of instruments are following 
c    iflag=1- standard SKD 
c    iflag=2- SKD with new parameters from file APPAR  
c    iflag>2- electronic instruments  
 
c-------------For nonstandard analog instrument------------------------ 
c    File APPAR should contain two lines. At the first line 
c    the following parameters should be given in a free format: 
c    vmag-magnification; tp-pendulum free period in sec; 
c    dp-relative damping of pendulum; tg and dg - the same 
c    for galvanometer; sig - squared coefficient of coupling 
c    between pendulum and galvanometer. 
c    At the second line any text describing seismometer 
c    can be given by the string of 12 characters. 
c    For analog instruments amplitude value is 
c    dimensionless (magnification at given frequency), 
c    for electronic instruments it has dimension "digital count/(m)" 
c    or "digital count/(m/sec)" or "digital count/(m/sec/sec)" 
c    depending on the type of instrument! 
c    Phase values are in radians within 0 - 2*PI range. 
c********************************************************************** 
c	include 'seis.inc'
c	RECORD /file_sei/ hds
      dimension amp(1024),phas(1024),hds_pol(2,50),hds_zer(2,20) 
      complex z(20),p(50) 

	integer hds_nzer,hds_npol
	real*4 hds_amp1	


c Mostinski



c          do 666 i = 1,hds_nzer
c        print *, hds_zer(1,i),hds_zer(2,i)
c 666        continue

c        do 6666 i = 1,hds_npol
c         print *, hds_pol(1,i),hds_pol(2,i)
c 6666        continue

 


c Mostinski

      f=f0 
      ind=0 
      amn=1 
      if (iflag.le.0)                         RETURN 
c-----for electronic instruments--------------------------------------- 
      if (iflag.gt.2)                           then 
c        call INQICP (zer,nzer, pol,npol) 
	 nzer = hds_nzer
	 npol = hds_npol
c        call INQAMC (ampc1,ampc2) 
	ampc1 = hds_amp1
        amn=amn/ampc1 
       
                            do 5 i=1,nzer 
       z(i)=cmplx(hds_zer(1,i),hds_zer(2,i)) 

5                           continue       
                            do 6 i=1,npol 
       p(i)=cmplx(hds_pol(1,i),hds_pol(2,i)) 
	
6     continue 
                                                 end if 
c------loop for frequencies-------------------------------------------- 
     
                            do 1 i=1,nf 
      call corin (am,ph,f,iflag,ind,z,p,nzer,npol) 
       
      ind=i 
      amp(i)=am/amn 
      phas(i)=ph 
      f=f+df 
1                           continue 
c        print *,iflag,nf,f0,df ,amp(5),phas(5)
      return 
      end 
c/////////////////////////////////////////////////////////////////////// 
c----------------------------------------------------------------------- 
              subroutine CORIN (am,ph,f,iflag,ind,z,p,nzer,npol) 
c----------------------------------------------------------------------- 
c----to calculate frequency response for different instruments: 
c----------------------------------------------------------------------- 
      complex z(20),p(50),xi,yi,t,q 
      character*12 prib 
c-------skd parameters-------------------------------------------------- 
        data tp /25./,dp /0.5/,tg /1.2/, dg /8.0/, sig /0.25/ 
        data  prib /'standard SKD'/  
c       for change make file "APPAR" with the the same two lines 
c----------------------------------------------------------------------- 
        data pi2 /6.28318/ 
c-----------pendulum-galvanometric instrument response------------------ 
        if((iflag.eq.2).and.(ind.eq.0))                         then 
                          open (1,file='APPAR') 
                          read (1,*)tp,dp,tg,dg,sig 
                          read (1,1000) prib  
1000    format(20a) 
                          close(1) 
        else if (iflag.gt.2)                    then 
                                goto 996 
                                               end if 
      if(ind.ne.0) go to 30 
c-------only in the first time--------------------------------------- 
      print* ,prib,tp,dp,tg,dg,sig 
      r=tg*tp 
      e=2.*(dp/tp+dg/tg) 
      er=1./tp/tp+1./tg/tg+4.*dg*dp/r*(1.-sig) 
      eq=2.*(dg/tp+dp/tg)/r 
      s=1./(r*r) 
      a=e*e-2.*er 
      b=er*er-2.*e*eq+2.*s 
      c=eq*eq-2.*er*s 
      d=s*s  
c-------all other times except the first one---------------------------- 
30    continue 
      t=f*f 
      ppp=-s+t*(er-t) 
      qqq=(-eq+e*t)*f 
      ph=pha(ppp,qqq) 
      am=e*t*f/sqrt(d+t*(c+t*(b+t*(a+t)))) 
                                        RETURN 
c----------------------------------------------------------------------- 
c             corrections for electronic instruments 
c----------------------------------------------------------------------- 
996                                     continue 
        xi=(.0,1.)*pi2 
        yi=xi*f 
        t=(1.,0.) 
              do 12 j=1,nzer 
                      q=(yi-z(j))*t 
                      t=q 
12                                      continue 
                        do 13 j=1,npol 
                                q=t/(yi-p(j)) 
                                t=q 
13                                      continue 
       am=cabs(t) 
        ac=real(t) 
        as=aimag(t) 
        ph=pha(as,ac)  
                                        RETURN 
                                        END 
c/////////////////////////////////////////////////////////////////////// 
c---------------------------------------------------------------------- 
        function PHA (y,x) 
c---------------------------------------------------------------------- 
        pi=3.14159 
        a=sqrt(x**2+y**2) 
        pha=asin(y/a) 
        if(x.lt.0.)   pha=pi-pha 
        if(pha.lt.0.) pha=pha+2.*pi 
                                                                RETURN 
                	                                                END 
                                                      
