//
// C++ Interface: polarities
//
// Description: 
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef POLARITIES_IMPLEMENTATION_H
#define POLARITIES_IMPLEMENTATION_H
#include "ui_polarity.h"
#include "projectwizard.h"
class Bulletin; 
class LineDocProperty;
class PropertyValue;
class MDocument;

class PolarImpl : public QDialog, private Ui::PolaritiesBase {
    Q_OBJECT

public:
    PolarImpl(QWidget *parent,MDocument* doc,ProWizard::DocumentUsing documentUsing);
    void FinishWizard();
    bool CheckDialogParameeters();

private slots:
    void buttonSmoothing();
    void  stateChangedSup(int state);
    void  stateChangedBul(int state);
    void  stateChangedSmoothing(int state);
    void  fileBrowseBul();
    void  fileBrowse();
private:
    MDocument* doc;
    ProWizard::DocumentUsing documentUsing;
    void InitDialog();
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    bool  GetSuplementaryPolar(QString fileName);
    bool GetBulletinPolar(QString fileName);
    bool ReadBuletin(QString fileName);
    bool GetVpSource();
    bool WriteFirstMotions(bool smoothing);
    QList<PropertyValue* > values;
    QList<LineDocProperty* > propDocLine;
    QStringList polarityData;
    QStringList bulletinData;
    Bulletin * bul;
    QString bulletinOutFileName;
    QString bulletinOutSmuFileName;
    QString SuplementaryPolarFileName;
    QString BulletinFileName;
};
#endif
