#include <QtGui>
#include <QMessageBox>
#include "mainwindow.h"  
#include  <math.h>
#include <default.h>
QString M0MTENS_ROOT_PATH;
QString M0MTENS_SEARCH_HELP_PATH;
int main(int argc, char *argv[]) {
    Q_INIT_RESOURCE(depth);

    QApplication app(argc, argv);
    if ( argc < 3) {
        QMessageBox::critical(0,mainWindowCaption(),"usage: depth \"curve file name\" \"PostScript file name\"");
        return 1;
    }

    QString fileName = QString(argv[1]);
    if (!(QFile::exists(fileName))) {
        QMessageBox::critical(0,mainWindowCaption(),
                              QString("File '%1' does not exist").arg(fileName),
                              QMessageBox::Close);
        return 1;
    }
    QFile file(fileName);
    if (!file.open(QFile::ReadOnly | QFile::Text)) {
        QMessageBox::warning(0,mainWindowCaption(),
                             QString("Cannot open file for reading\n%1:\n%2.")
                             .arg(fileName)
                             .arg(file.errorString()));
        return 1;
    }
    QTextStream in(&file);
    QString line;
    QList<float> XData;
    QList<float> YData;
    do {
        line = in.readLine();
        QStringList lst = line.split(' ', QString::SkipEmptyParts);
        if (lst.size() < 2) break;
        if ( fabs(lst.at(1).toFloat() - (float) 99.0) < 0.1e-6) continue;
        XData << lst.at(0).toFloat();
        YData << lst.at(1).toFloat();
    } while (!line.isNull());
    file.close();

    app.setStyle(QStyleFactory::create("plastique"));
    QApplication::setPalette(QApplication::style()->standardPalette());
    QString absoluteInstallEcpPath = app.applicationDirPath();
    int pos = absoluteInstallEcpPath.lastIndexOf("/bin");
    absoluteInstallEcpPath.remove ( pos, 4 );
    M0MTENS_ROOT_PATH = absoluteInstallEcpPath;
#if defined(Q_WS_WIN)
    M0MTENS_SEARCH_HELP_PATH = "file:///" + M0MTENS_ROOT_PATH + "/doc";
#endif
#if defined(Q_WS_X11)
    M0MTENS_SEARCH_HELP_PATH = "file://" + M0MTENS_ROOT_PATH + "/doc";
#endif
#if defined(Q_WS_MAC)
    M0MTENS_SEARCH_HELP_PATH = "file://" + M0MTENS_ROOT_PATH + "/doc";
#endif


    MainWindow mainWin(XData,YData,QString(argv[2]));
    mainWin.show();
    return app.exec();
}
