//	SpPrSave.cpp:	Source for CSpPrSave class
//=======================================================================
#include <stdio.h>
#include "FmtEcmdw.h"
#include "SpPrSave.h"

CSpPrSave::CSpPrSave(){
  strcpy(m_WorkDir,"");
  strcpy(DirSacName,"");
  strcpy(OriginName,"");
  N_SelStaList    = 0;
  SelStaList      = 0;
  NMainShock = 0;

}
CSpPrSave::~CSpPrSave(){
   Delete2DCharArray(N_SelStaList,SelStaList);

}
CSpPrSave::CSpPrSave(char *Name,char *OutErr) {
FILE *in;
 if ((in = fopen(Name, "r")) == NULL)
	   {
	    (void) fprintf(stderr, "\tFatal Error (SpPrcss):  ");
	    (void) fprintf(stderr,
			   "Fatal Error: Input file %s is not available for riding.\n",
			   Name);
	    sprintf( OutErr, "Fatal Error: Input file %s is not available for riding.\n",
			   Name);
	    return;
	  }
char dummy[256];

fscanf(in,"%s%s",m_WorkDir,dummy);
//fprintf(stderr,"SpPrSave Open: WorkDir %s\n",m_WorkDir);
fscanf(in,"%s%s",DirSacName,dummy);
//fprintf(stderr,"SpPrSave Open: DirSacName %s\n",m_DbeName);
fscanf(in,"%s%s",OriginName,dummy);
//fprintf(stderr,"SpPrSave Open: OriginName %s\n",m_DbeRootName);
fscanf(in,"%d%s",&NMainShock,dummy);


int i;



fscanf(in,"%d%s\n",&N_SelStaList,dummy);
fprintf(stderr,"%d records in Selected Station List\n",N_SelStaList);
//if (SelStaList != 0)   	delete [] SelStaList;
SelStaList = new char *[N_SelStaList];
for (i = 0 ; i < N_SelStaList; i++) {
SelStaList[i] = new char[64];
fgets(SelStaList[i],63,in);
*strchr(SelStaList[i],'\n') = '\0';
}



fclose ( in ) ;
strcpy(OutErr,"");
}
int CSpPrSave::SaveAs(char *Name,char *OutErr) {
 FILE *out;
  if ((out = fopen(Name, "w")) == NULL)
	   {
	    (void) fprintf(stderr, "\tFatal Error (SpPrSave):  ");
	    (void) fprintf(stderr,
			   "Fatal Error: OutPut file %s is not available for writing.\n",
			   Name);
	    sprintf( OutErr, "Fatal Error: Input file %s is not available for riding.\n",
			   Name);
	    return 1;
	  }

fprintf(out,"%s  Working_directory\n",m_WorkDir);
fprintf(out,"%s  Sac_File_Location_Directory\n",DirSacName);
fprintf(out,"%s  Catalogs_File_Name\n",OriginName);
fprintf(out,"%d  Main_Shock_Num_in_Db_Origin_Table\n",NMainShock);


int i;

fprintf(out,"%d Records_in_Selected_Station_List:\n",N_SelStaList);
for (i = 0 ; i < N_SelStaList; i++) {
fprintf(out,"%s\n",SelStaList[i]);
}

fclose ( out ) ;
fprintf(stderr,"Info: Save Project As %s \n",Name);

return 0;
}
  void CSpPrSave::Set_SelStaList(int N,char **NewList){
 if (N <=0) return;
   Delete2DCharArray(N_SelStaList,SelStaList);
    N_SelStaList  = N;
      SelStaList = new char * [N];
     int Strl = 0;
     for (int j = 0; j < N; j++)
     if (Strl < strlen(NewList[j]) ) Strl = strlen(NewList[j]);

     for (int i = 0; i < N; i++)  {
     SelStaList  [i] = new char [Strl+1];
     strcpy(SelStaList [i],NewList[i]);
     }
}
