#ifndef DbeCi_SEI_H
#define DbeCi_SEI_H
#define TRUE   1 
#define FALSE  0 
typedef int BOOL;
#define  _MAX_LENGTH_NAME  200
 typedef struct orig {

	int doy, last_doy, orid, evid;
	char etype[32];
	char dtype[32];
	char algorithm[32];
        char author[64];
        double epoph;
	double lddate;

    int year,month,day,hour,minute;
    float second;
    float latitude;                     /*  latitude */
    float longitude;                  /*  longitude */
    float dep;                        /*  dep */
    float mb;                      /* mb   */
    float ms;                      /* ms   */
    float ml;                      /* ml   */
} ORIG;
    
typedef struct file_sei 
     { 
/*  ======================= common  START =======================*/ 
                           /*    fortran record 1 >: */ 
      short rec_cod1; 
      char rectyp[4];      /* identifier   */ 
      long  nh;             /* number of records before array */ 
      
/* ======================= common HEADER =======================*/ 
                           /* fortran record 2 >: */ 
      short rec_cod2; 
      long lh;              /* lh=168 - length of common header */ 
 
                           /* fortran record 3 >: (character 168)*/ 
      short rec_cod3; 
      char header[79];     /*  comment             */ 
      char comp[2];           /*  component (z,n,e,r,t)   */ 
      char instr[9];       /*  type of seismometer */ 
      char st_name[10];        /*  station name        */ 
 
/* ----------------------- Origin time >: -----------------------*/ 
                               
      long  year; 
      long  month; 
      long  day; 
      long  hour; 
      long  minute; 
      float sec; 
 
/* ----------------------- hypocenter  >: -----------------------*/ 
 
      float elat; 
      short spec_code; 
      float elong; 
      float depth;   
 
/* ----------------------- station     >: -----------------------*/ 
 
      float slat; 
      float slong; 
      float elevation; 
 
/* ---------- instrument's orientation (degrees) >: -------------*/ 
 
      float polan;         /*  angle with vertical   */    
      float az;            /*  azimuth               */ 
      float dist;          /*  distance from Station */ 
                           /*  to epicenter          */ 
      float aztos;         /*  azimuth to Station    */ 
      float azfrs;         /*  azimuth from Station  */ 
                                                      
/* ======================= TIME - HEADER ============================*/ 
 
                           /* fortran record 4 >:  */ 
       short rec_cod4; 
       long  lh_time;         /* lh_time=16 - length of time-header */ 
 
                           /* fortran record 5 >:  */ 
       short rec_cod5; 
       long  nsampl;        /* number of Points     */ 
       float  t0;            /* Start time of record */ 
       float  dt;            /* Time interval        */ 
       float  amp;           /* signal amplitude     */ 
                                    
/* ===================RESPONSE - HEADER =============================*/ 
 
                           /* fortran record 6 >:  */ 
 /* record 6 information about response (1 record) */ 
 
       short rec_cod6; 
        long  icot;             /* type of instrument correction :   */ 
                                /* icot   = 0  -  uncertain          */ 
            /* ABS(icot)  = 1  -  no correction in the past          */ 
            /* ABS(icot)  = 2  -  wrong information about correction */ 
            /* ABS(icot)  > 2  -  type of correction                 */ 
            /*    "icot" always is WRITTEN into file "namo"          */ 
            /*     but information itself ONLY if  incor > 0         */ 
        char rsptype[7];
        long   nzer;            /* number of zeros                   */ 
        long   npol;            /* number of poles                   */ 
        float  amp1;            /* a leading factor of the           */ 
                                /*          instrumental response    */  
        float  amp2;            /* sensitivity of instrument, bit/m  */ 
        float  zer[20][2];      /* array of zeros (re,im)            */ 
        float  pol[50][2];      /* array of poles (re,im)            */ 
/*  ======================= End definition ======================*/ 
   char name[30];

/*   To SPDISC              */
    char      sta[7];
    char      n_sta[12];
    char      chan[9];
    char      inichan[9];
    char      LRchan[9];
    long      chanid; 
    double    time;
    double    endtime;
    long      jdate;
    long      nsamp ;
    float     calib ;
    float     calper ;
    float     samprate ;
    char      segtype;
/*   ---------------------   */
    char      dir[_MAX_LENGTH_NAME];
    char      dfile[_MAX_LENGTH_NAME]; 
    long      wfid;
    char      instype[7];
    char      datatype[3];
    char      clip[2];
    long      foff;
    long      commid ; 
    double     lddate;
    char  dir_instr[_MAX_LENGTH_NAME];
    char  dfile_instr[_MAX_LENGTH_NAME];

        float *s;
      } SEI; 
typedef struct set_sei 
     { 
      int n;
      long max_nsampl;
      char *dir_locate;
      SEI **sei;  
       int n_or;
       ORIG **ori;
      } SET_SEI; 
  
#define N_SEI            ps->n 



#endif
