//	SpPrmdlg.h:	Header for SpePrepMDRange class
//=======================================================================

#ifndef SpePrepMDRange_H
#define SpePrepMDRange_H

#include <v/vmodald.h>
class CDbeSeis;
    class SpePrepCmdWindow;

    class SpePrepMDRange : public vModalDialog
      {
      public:		//---------------------------------------- public
                       
                        SpePrepMDRange(vBaseWindow* bw, char* title = "Spectra Preparation V App");
	virtual ~SpePrepMDRange();		// Destructor
	virtual void DialogCommand(ItemVal,ItemVal,CmdType); // action selected
	virtual int SpePrepAction(char* msg);
        void Set_RecPeriodList(char **,  int );
        void Set_RecDescrList (char **,  int );
        void Set_CombN2NList  (char **,  int );
 int Fill_RecDescrList(char *);
 int Fill_LineList(char *);


int Set_PreSpeArray(float *,float *,float *,float * ,float *,int *);
     void Set_TMin       (float ATMin       ){ TMin = ATMin;             };
     void Set_TMax       (float ATMax       ){ TMax = ATMax;             };
     void Set_PhVelTmin  (float APhVelTmin  ){PhVelTmin = APhVelTmin;    };
     void Set_ComTmin    (float AComTmin    ){ComTmin = AComTmin;        };
     void Set_CorrComTmin(float ACorrComTmin){CorrComTmin = ACorrComTmin;};
     void Set_ComTmax    (float AComTmax    ){ComTmax = AComTmax;        };
     void Set_CorrComTmax(float ACorrComTmax){CorrComTmax = ACorrComTmax;};
     void Set_NPoints    (int   ANPoints    ){NPoints = ANPoints;        };
     void Set_TotalNum   (int   ATotalNum   ){TotalNum = ATotalNum;      };
     void Set_N2N        (long  AN2N        ){N2N = AN2N;                };
     void Set_PhVelCheck (int   APhVelCheck ){PhVelCheck = APhVelCheck;  };


     float Get_TMin       (){return TMin;       };
     float Get_TMax       (){return TMax;       };
     float Get_PhVelTmin  (){return PhVelTmin;  };
     float Get_ComTmin    (){return ComTmin;    };
     float Get_CorrComTmin(){return CorrComTmin;};
     float Get_ComTmax    (){return ComTmax;    };
     float Get_CorrComTmax(){return CorrComTmax;};
     int   Get_NPoints    (){return NPoints;    };
     int   Get_TotalNum   (){return TotalNum;   };
     long  Get_N2N        (){return N2N;        };
     int   Get_PhVelCheck (){return PhVelCheck; };



        char ** Get_RecPeriodList() {return RecPeriodList; };
        char ** Get_RecDescrList()  {return RecDescrList;  };
        char ** Get_CombN2NList()   {return CombN2NList;  };

       
         int   Get_N_RecPeriodList  ()    { return  N_RecPeriodList;};
         int   Get_N_RecDescrList   ()    { return N_RecDescrList;  };
         int   Get_N_CombN2NList    ()    { return N_CombN2NList;   };

          void Set_Control(int Con)  {Control = Con ;};
          int Get_Control(){return Control;};
          CDbeSeis *pCDbeSeis;
        
        float   m_dt;           
	float * m_w_min;  
	float * m_w_max;   
	float * m_t_min;  
	float * m_t_max;	 
	float * m_dw0; 
	int   * m_ipoint; 
	 
	float   m_dw;    
	int m_nitems ; 

      protected:	//--------------------------------------- protected

      private:		//---------------------------------------private 
         int Control; 
         int  N_RecPeriodList;
         int  N_RecDescrList;
         int  N_CombN2NList;
         int  N_LineList;
         char ** RecPeriodList;
         char ** RecDescrList;
         char **OldRecPeriodList;
         char **OldRecDescrList;
         char **CombN2NList;
         char **OldCombN2NList;
         char ** LineList;
     float TMin;
     float TMax;
     float PhVelTmin;
     float ComTmin;
     float CorrComTmin;
     float ComTmax;
     float CorrComTmax;
     int   NPoints;
     int   TotalNum;
     long  N2N;
     int   PhVelCheck;
     bool CheckGetButton;
         SpePrepCmdWindow* _myCmdWin;
      };

  
#endif

