#include <string.h>    
 
  class   HEADER_SEI 
         { 
/* ======================= common HEADER =======================*/ 
      char header[79];     /*  comment             */ 
      char comp[1];           /*  component (z,n,e)   */ 
      char instr[9];       /*  type of seismometer */ 
      char st_name[10];        /*  station name        */ 
/* ----------------------- Origin time >: -----------------------*/ 
 
      long  year; 
      long  month; 
      long  day; 
      long  hour; 
      long  minute; 
      float sec; 
 
/* ----------------------- hypocenter  >: -----------------------*/ 
 
      float elat; 
      float elong; 
      float depth; 
 
/* ----------------------- station     >: -----------------------*/ 
 
      float slat; 
      float slong; 
      float elevation; 
 
/* ---------- instrument's orientation (degrees) >: -------------*/ 
 
      float polan;         /*  angle with vertical   */ 
      float az;            /*  azimuth               */ 
      float dist;          /*  distance from Station */ 
                           /*  to epicenter          */ 
      float aztos;         /*  azimuth to Station    */ 
      float azfrs;         /*  azimuth from Station  */ 
 
/* ======================= TIME - HEADER ============================*/ 
       long  nsampl;        /* number of Points     */ 
       float  t0;            /* Start time of record */ 
       float  dt;            /* Time interval        */ 
       float  amp;           /* signal amplitude     */ 
/* ===================RESPONSE - HEADER =============================*/ 
        long  icot;             /* type of instrument correction :   */ 
                                /* icot   = 0  -  uncertain          */ 
            /* ABS(icot)  = 1  -  no correction in the past          */ 
            /* ABS(icot)  = 2  -  wrong information about correction */ 
            /* ABS(icot)  > 2  -  type of correction                 */ 
            /*    "icot" always is WRITTEN into file "namo"          */ 
            /*     but information itself ONLY if  incor > 0         */ 
        long   nzer;            /* number of zeros                   */ 
        long   npol;            /* number of poles                   */ 
        float  amp1;            /* a leading factor of the           */ 
                                /*          instrumental response    */ 
        float  amp2;            /* sensitivity of instrument, bit/m  */ 
        float  zer[20][2];      /* array of zeros (re,im)   */ 
        float  pol[50][2];       /*array of poles (re,im)   */ 
/*  ======================= End definition ======================*/ 
 public: 
                    HEADER_SEI();  
 
virtual                   ~HEADER_SEI(); 
     void Write_Seismo(char *,float *); 
     void Read_Seismo(char *,float *,int st = 0,int fn = 0); 
 
              void Set_header  (char *hd    )  { 
     for (int i = 0; i< 80;i++) header[i] = 0x20; 
     if ( (i = strlen (hd) ) >78 ) hd[79] =  '\0'; 
     strcpy(header,  hd    );    } 
 
              void Set_comp    (char *cm    )  {  comp[0] =    cm[0]; } 
              void Set_instr   (char *inst  )  { 
                   for (int i = 0; i< 10;i++) instr[i] = 0x20; 
                       if ( (i = strlen (inst) ) >8 ) inst[9] =  '\0'; 
                       strcpy(instr,   inst  );} 
              void Set_st_name (char *st_nam)  { 
                   for (int i = 0; i< 11;i++) st_name[i] = 0x20; 
                   if ( (i = strlen (st_nam) ) >9 ) st_nam[10] =  '\0'; 
                         strcpy(st_name, st_nam);} 
 
char *Get_header  (char *hd    )  { return strcpy(    hd,header );} 
char *Get_comp    (char *cm    )  { return strcpy(    cm,comp   );} 
char *Get_instr   (char *inst  )  { return strcpy(  inst,instr  );} 
char *Get_st_name (char *st_nam)  { return strcpy(st_nam,st_name);} 
                                                                    
char *Get_header  (  )  { return header ;} 
char *Get_comp    (  )  { return comp   ;} 
char *Get_instr   (  )  { return instr  ;} 
char *Get_st_name (  )  { return st_name;} 
                                                                    
              void  Set_year    (long  yea   )  { year  = yea   ;} 
              void  Set_month   (long  mont  )  { month = mont  ;} 
              void  Set_day     (long  da    )  { day   = da    ;} 
              void  Set_hour    (long  hou   )  { hour  = hou   ;} 
              void  Set_minute  (long  minut )  { minute= minut ;} 
              void  Set_sec     (float se    )  { sec   = se    ;} 
 
long  Get_year    (  )  { return ( year   );} 
long  Get_month   (  )  { return ( month  );} 
long  Get_day     (  )  { return ( day    );} 
long  Get_hour    (  )  { return ( hour   );} 
long  Get_minute  (  )  { return ( minute );} 
float Get_sec     (  )  { return ( sec    );} 
 
       long  Get_year    (long&  yearr )  { return ( yearr = year  );} 
       long  Get_month   (long&  monthh )  { return ( monthh = month);} 
       long  Get_day     (long&  dayy )  { return ( dayy =  day  );}; 
       long  Get_hour    (long&  hourr )  { return ( hourr = hour   );} 
       long  Get_minute  (long&  minutee )  { return ( minutee = minute );} 
       float Get_sec     (float& secc )  { return ( secc = sec   );}  
        
              void  Set_elat    (float ela  )  { elat  =  ela    ;} 
              void  Set_elong   (float elon )  { elong =  elon   ;} 
              void  Set_depth   (float dept )  { depth =  dept   ;} 
 
float Get_elat    (float& elatt )  { return ( elatt = elat     );} 
float Get_elong   (float& elongg )  { return ( elongg = elong    );} 
float Get_depth   (float& depthh )  { return ( depthh = depth    );} 
  float Get_elat    ( )  { return ( elat     );} 
  float Get_elong   ( )  { return ( elong    );} 
  float Get_depth   ( )  { return ( depth    );} 
 
              void  Set_slat     (float  sla      )  {  slat      = sla      ;} 
              void  Set_slong    (float  slon     )  {  slong     = slon     ;} 
              void  Set_elevation(float  elevatio )  {  elevation = elevatio ;} 
              void  Set_polan    (float  pola     )  {  polan     = pola     ;} 
              void  Set_az       (float  azz      )  {  az        = azz      ;} 
              void  Set_dist     (float  dis      )  {  dist      = dis      ;} 
              void  Set_aztos    (float  azto     )  {  aztos     = azto     ;} 
              void  Set_azfrs    (float  azfr     )  {  azfrs     = azfr     ;} 
              void  Set_nsampl   (long   nsamp    )  {  nsampl    = nsamp    ;} 
              void  Set_t0       (float  t00      )  {  t0        = t00      ;} 
              void  Set_dt       (float  dtt      )  {  dt        = dtt      ;} 
              void  Set_amp      (float  am       )  {  amp       = am       ;} 
              void  Set_icot     (long   ico      )  {  icot      = ico      ;} 
              void  Set_amp1     (float  ampp1    )  {  amp1      = ampp1    ;} 
              void  Set_amp2     (float  ampp2    )  {  amp2      = ampp2    ;} 
 
 
float Get_slat     (float&  sla      )  { return (  sla     = slat      );} 
float Get_slong    (float&  slon     )  { return (  slon    = slong     );} 
float Get_elevation(float&  elevatio )  { return (  elevatio= elevation );} 
float Get_polan    (float&  pola     )  { return (  pola    = polan     );} 
float Get_az       (float&  azz      )  { return (  azz     = az        );} 
float Get_dist     (float&  dis      )  { return (  dis     = dist      );} 
float Get_aztos    (float&  azto     )  { return (  azto    = aztos     );} 
float Get_azfrs    (float&  azfr     )  { return (  azfr    = azfrs     );} 
long  Get_nsampl   (long&   nsamp    )  { return (  nsamp   = nsampl    );} 
float Get_t0       (float&  t00      )  { return (  t00     = t0        );} 
float Get_dt       (float&  dtt      )  { return (  dtt     = dt        );} 
float Get_amp      (float&  am       )  { return (  am      = amp       );} 
long  Get_icot     (long&   ico      )  { return (  ico     = icot      );} 
float Get_amp1     (float&  ampp1    )  { return (  ampp1   = amp1      );} 
float Get_amp2     (float&  ampp2    )  { return (  ampp2   = amp2      );} 
 
float Get_slat     ( )  { return ( slat      );} 
float Get_slong    ( )  { return ( slong     );} 
float Get_elevation( )  { return ( elevation );} 
float Get_polan    ( )  { return ( polan     );} 
float Get_az       ( )  { return ( az        );} 
float Get_dist     ( )  { return ( dist      );} 
float Get_aztos    ( )  { return ( aztos     );} 
float Get_azfrs    ( )  { return ( azfrs     );} 
long  Get_nsampl   ( )  { return ( nsampl    );} 
float Get_t0       ( )  { return ( t0        );} 
float Get_dt       ( )  { return ( dt        );} 
float Get_amp      ( )  { return ( amp       );} 
long  Get_icot     ( )  { return ( icot      );} 
float Get_amp1     ( )  { return ( amp1      );} 
float Get_amp2     ( )  { return ( amp2      );} 
 
 
 
              void  Set_zer_pol  (int nzzer, float **zzer,int nppol,float **ppol) 
                                  { 
                 nzer = nzzer;  for (int i = 0; i < nzer;i++) { 
                 zer[i][0] = zzer[i][0]; zer[i][1] = zzer[i][1];} 
                  npol = nppol;  for ( i = 0; i < npol;i++) { 
                  pol[i][0] = ppol[i][0]; pol[i][1] = ppol[i][1];} 
                                  } 
void  Set_zer_pol  (int nzzer, float zzer[20][2],int nppol,float ppol[50][2]) 
                                  { 
                 nzer = nzzer;  for (int i = 0; i < nzer;i++) { 
                 zer[i][0] = zzer[i][0]; zer[i][1] = zzer[i][1];} 
                  npol = nppol;  for ( i = 0; i < npol;i++) { 
                  pol[i][0] = ppol[i][0]; pol[i][1] = ppol[i][1];} 
                                  } 
 
void  Get_zer_pol  (int& nzzer, float **zzer,int& nppol,float **ppol) 
{ 
nzzer = (int)nzer;  for (int i = 0; i < nzer;i++) { 
zzer[i][0] = zer[i][0]; zzer[i][1] = zer[i][1];} 
nppol = (int)npol;  for ( i = 0; i < npol;i++) { 
ppol[i][0] = pol[i][0]; ppol[i][1] = pol[i][1];} 
} 
void  Get_zer_pol  (int& nzzer, float zzer[20][2],int& nppol,float ppol[50][2]) 
{ 
nzzer = (int)nzer;  for (int i = 0; i < nzer;i++) { 
zzer[i][0] = zer[i][0]; zzer[i][1] = zer[i][1];} 
nppol = (int)npol;  for ( i = 0; i < npol;i++) { 
ppol[i][0] = pol[i][0]; ppol[i][1] = pol[i][1];} 
} 
long Get_nzer() { return (nzer); } 
long Get_npol() {return  (npol); } 
float Get_re_zer(int i) { return (zer[i][0]);} 
float Get_im_zer(int i) { return (zer[i][1]);} 
float Get_re_pol(int i) { return (pol[i][0]);} 
float Get_im_pol(int i) { return (pol[i][1]);}  
 
void Set_nzer(long nnzer) { nzer = nnzer; } 
void Set_npol(long nnpol) { npol = nnpol; } 
void Set_re_zer(int i,float f) { zer[i][0] = f;} 
void Set_im_zer(int i,float f) { zer[i][1] = f;} 
void Set_re_pol(int i,float f) { pol[i][0] = f;} 
void Set_im_pol(int i,float f) { pol[i][1] = f;} 
 
  }; 
