czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        Subroutine GREEN1(cs,ugrs,sumi0s,vzs,vrfs,dvzs,dvrfs,cr,ugrr,
     *  sumi0r,vrr,lr,omega,r,fi,caver,g,ierr)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c---------------------------------------------------------------------
c       This program calculates g(j,k,l) - the 1-st derivative of Green
c       function spectrum g(j,k) for Rayleigh (or Love) mode of a given
c       frequency 'omega' with respect to z for l=1, to x for l=2 and
c       to y for l=3.
c       Index s - source, index r - receiver.
c       c - phase velocities; ugr - group velocities; sumi0 - I0;
c       vz,vrf - z and r (or fi) components of eigenfunction;
c       dvzs,dvrfs - derivatives of eigenfunctions at the source with
c       respect to z; lr - if lr=0, then Love waves will be calculated,
c       else - Rayleigh waves; omega - circle frequency;
c       r - length of the ray; fi - azimuth of receiver;
c       caver - average phase velocity along the ray;
c       g - complex array g(3,3,3) - result of program.
c---------------------------------------------------------------------
        real*4 ksis,ksir
        complex g(3,3,3),a,a1,b(3),dws(3,3),wr(3),dvf(3),cr1
	ierr=0
        r0=6371. 
        delta=r/r0
        pi=3.141592
        r1=3.*2.*pi*cs/omega
                        if(abs(20015.-r).gt.r1) go to 1
	ierr=2
                                                        RETURN
1                                       continue
        r1=1/(8.*pi)
        r1=sqrt(r1)
        r2=pi/4.
        cr1=(0.,-1.)*r2
        cr1=cexp(cr1)
        a1=cr1*r1
        sinfi=sin(fi)
        cosfi=cos(fi)
                        if(lr.eq.0)             go to 2000
c----------------------------------------------------------------------
c       Rayleigh waves calculations
c----------------------------------------------------------------------
        ksis=omega/cs
        ksir=omega/cr
        r1=cs*ugrs*sumi0s
        r1=sqrt(r1)
        r2=cr*ugrr*sumi0r
        r1=sqrt(r2)*r1
        r2=ksir*abs(sin(delta))*r0
        r1=sqrt(r2)*r1
        cr1=(0.,-1.)*omega*r/caver
        cr1=cexp(cr1)
        cr1=a1*cr1
        a=cr1/r1
        b(1)=1.
        b(2)=(0.,1.)*cosfi
        b(3)=(0.,1.)*sinfi
        wr(1)=1.
        wr(2)=vrr*b(2)
        wr(3)=vrr*b(3)
        dws(1,1)=dvzs
        r1=ksis*vzs
        dws(1,2)=r1*b(2)
        dws(1,3)=r1*b(3)
        dws(2,1)=dvrfs*b(2)
        r1=ksis*vrfs
        dws(2,2)=r1*b(2)*b(2)
        dws(2,3)=r1*b(3)*b(2)
        dws(3,1)=dvrfs*b(3)
        dws(3,2)=r1*b(2)*b(3)
        dws(3,3)=r1*b(3)*b(3)
                                do 1100 j=1,3
        j1=j*(j-1)/2
        jj=(-1)**j1
        cr1=a*wr(j)*jj
                                do 1100 k=1,3
                                do 1100 l=1,3
        g(j,k,l)=cr1*dws(k,l)
1100                                    continue
                                                        go to 3000
c----------------------------------------------------------------------
c       Love waves calculations
c----------------------------------------------------------------------
2000    ksis=omega/cs
        ksir=omega/cr
        r1=cs*ugrs*sumi0s
        r1=sqrt(r1)
        r2=cr*ugrr*sumi0r
        r1=sqrt(r2)*r1
        r2=ksir*abs(sin(delta))*r0
        r1=-sqrt(r2)*r1
        cr1=(0.,-1.)*omega*r/caver
        cr1=cexp(cr1)
        cr1=a1*cr1
        a=cr1/r1
        b(1)=0.
        b(2)=(0.,1.)*sinfi
        b(3)=-(0.,1.)*cosfi
        dvf(1)=dvrfs
        r1=vrfs*ksis*cosfi
        dvf(2)=(0.,1.)*r1
        r1=vrfs*ksis*sinfi
        dvf(3)=(0.,1.)*r1
                                do 2100 j=1,3
                                do 2100 k=1,3
                                do 2100 l=1,3
        g(j,k,l)=a*b(j)*b(k)*dvf(l)
c----------------------------------------------------------------------
c       At the recorder vfi(0)=1.
c----------------------------------------------------------------------
2100                                    continue
3000                                    continue
                                                                RETURN
                                                                END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
      subroutine flat(h,ro,vp,vs,n,kind)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c     subroutine applies earth-flattening corrections by
c     scaling the model.for reference see Biswas 1972.
c     kind=1 for Love wave calculations
c     kind=2 for Rayleigh wave calculations
      implicit real*8(a-h,o-z)
      real*8 h(100),ro(100),vp(100),vs(100)
      data a/6371.d0/
      pwr=2.275d0
      if(kind.eq.1) pwr=5.d0
      nm=n-1
      hs=0.d0
      do 5 i=1,n
      ht=hs
      hs=hs+h(i)
    5 h(i)=a-ht
      do 10 i=1,nm
      ii=i+1
      fltd=dlog(h(i)/h(ii))
      dif=(1.d0/h(ii)-1.d0/h(i))*a/fltd
      difr=h(i)**pwr-h(ii)**pwr
      ro(i)=ro(i)*difr/(fltd*(a**pwr)*pwr)
      vp(i)=vp(i)*dif
   10 vs(i)=vs(i)*dif
c half space scaling
      fact=a/h(n)
      vp(n)=vp(n)*fact
      vs(n)=vs(n)*fact
      ro(n)=ro(n)*(1.d0/fact)**pwr
      z0=0.d0
      do 15 i=2,n
      z1=a*dlog(a/h(i))
      h(i-1)=z1-z0
   15 z0=z1
      h(n)=0.d0
      return
      end
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	function psgn(un1,un2,rl)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c----------------------------------------------------------------------
c	Program calculates radiation pattern of P-waves:
c	Fp=2*(rl,un1)*(rl,un2). If abs(Fp)<0.1, then psgn=0,
c	else psgn=sign(Fp).
c	rl - ray's orth; un1, un2 - unit vectors of slip and normal to
c	the falt's plane.
c----------------------------------------------------------------------
	real*4 un1(3),un2(3),rl(3)
	r1=0.
	r2=0.
		do 1 i=1,3
	r1=r1+rl(i)*un1(i)
	r2=r2+rl(i)*un2(i)
1		continue
	f=2.*r1*r2
	af=abs(f)
	psgn=0.
			if(af.ge.0.1)	psgn=f/af
				RETURN
				END
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
	function psgnexdc(un1,un2,rl,aex,adc,ipola,rpola)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c----------------------------------------------------------------------
c	Program calculates radiation pattern of P-waves:
c	Fp=adc*2*(rl,un1)*(rl,un2)+sqrt(2/3)*aex. If abs(Fp)<0.1, 
c	then psgn=0, else psgn=sign(Fp).
c	rl - ray's orth; un1, un2 - unit vectors of slip and normal to
c	the falt's plane.
c----------------------------------------------------------------------
	real*4 un1(3),un2(3),rl(3)
	r1=0.
	r2=0.
		do 1 i=1,3
	r1=r1+rl(i)*un1(i)
	r2=r2+rl(i)*un2(i)
1		continue
	f=2.*adc*r1*r2+sqrt(2./3.)*aex
	af=abs(f)
	psgnexdc=0.
		if(ipola.eq.0.and.af.ge.rpola)	psgnexdc=f/af
			if(ipola.eq.1) then
			rneg=-rpola*(adc-sqrt(2./3.)*aex)
			rpos=rpola*(adc+sqrt(2./3.)*aex)
			if(f.lt.rneg.or.f.gt.rpos) psgnexdc=f/af
			end if
				RETURN
				END
