czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        Subroutine GREEN3(cs,ugrs,sumi0s,vzs,vrfs,dvzs,dvrfs,d2vzs,
     *  d2vrfs,d3vzs,d3vrfs,cr,ugrr,sumi0r,vrr,lr,omega,r,fi,caver,g)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Program calculates g(j,k,l,m,n) - the 3-d derivative of Green
c       function spectrum G(j,k) for Rayleigh (or Love) mode of a given
c       frequency 'omega'. l,m,n=1 - derivation with respect to z,
c       l,m,n=2 - to x, l,m,n=3 - to y.
c       Index s - source, index r - receiver.
c       c - phase velocities; ugr - group velocities; sumi0 - I0; vz,
c       vrf - z and r (or fi) components of eigenfunction; dvzs,dvrfs,
c       d2vzs,d2vrfs,d3vzs,d3vrfs - eigenfunctions' derivatives at the 
c       source with respect to z; lr - if lr=0, then Love waves will be
c       calculated, else - Rayleigh waves; omega - circular frequency;
c       r - length of the ray; fi - azimuth of receiver;
c       caver - average phase velocity along the ray;
c       g - complex array g(3,3,3,3,3) - result of program.
c-----------------------------------------------------------------------
        real*4 ksis,ksir
        complex g(3,3,3,3,3),a,a1,b(3),wr(3),cr1,der(3,4)
        r0=6371.
        delta=r/r0
        pi=3.141592
        r1=3.*2.*pi*cs/omega
c                        if(abs(20015.-r).gt.r1) go to 1
c        print*,'distant',r,'km      is  too close to the antiepicentre'
c                                                        STOP
c1                                       continue
        r1=1/(8.*pi)
        r1=sqrt(r1)
        r2=pi/4.
        cr1=(0.,-1.)*r2
        cr1=cexp(cr1)
        a1=cr1*r1
        sinfi=sin(fi)
        cosfi=cos(fi)
                        if(lr.eq.0)             go to 2000
c-----------------------------------------------------------------------
c       Rayleigh waves calculations
c-----------------------------------------------------------------------
        ksis=omega/cs
        ksir=omega/cr
        r1=cs*ugrs*sumi0s
        r1=sqrt(r1)
        r2=cr*ugrr*sumi0r
        r1=sqrt(r2)*r1
        r2=ksir*abs(sin(delta))*r0
        r1=sqrt(r2)*r1
        cr1=(0.,-1.)*omega*r/caver
        cr1=cexp(cr1)
        cr1=a1*cr1
        a=cr1/r1
        b(1)=1.
        b(2)=(0.,1.)*cosfi
        b(3)=(0.,1.)*sinfi
        wr(1)=1.
        wr(2)=vrr*b(2)
        wr(3)=vrr*b(3)
        der(1,1)=vzs
        der(2,1)=vrfs*b(2)
        der(3,1)=vrfs*b(3)
        der(1,2)=dvzs
        der(2,2)=dvrfs*b(2)
        der(3,2)=dvrfs*b(3)
        der(1,3)=d2vzs
        der(2,3)=d2vrfs*b(2)
        der(3,3)=d2vrfs*b(3)
        der(1,4)=d3vzs
        der(2,4)=d3vrfs*b(2)
        der(3,4)=d3vrfs*b(3)
        b(2)=ksis*b(2)
        b(3)=ksis*b(3)
                                do 1100 j=1,3
        j1=j*(j-1)/2
        jj=(-1)**j1
        cr1=a*wr(j)*jj
                                do 1100 k=1,3
        kl=3                               
                                do 1100 l=1,3
                if(l.gt.1) kl=2
                                do 1100 m=1,3
        km=kl
                if(m.gt.1) km=kl-1
                                do 1100 n=1,3
        kn=km
                if(n.gt.1) kn=km-1
c----------------------------------------------------------------------
c       kn - order of derivative with respect to z
c----------------------------------------------------------------------
        kn=kn+1
        g(j,k,l,m,n)=cr1*der(k,kn)*b(l)*b(m)*b(n)
1100                                    continue
                                                        go to 3000
c-----------------------------------------------------------------------
c       Love waves calculations
c-----------------------------------------------------------------------
2000    ksis=omega/cs
        ksir=omega/cr
        r1=cs*ugrs*sumi0s
        r1=sqrt(r1)
        r2=cr*ugrr*sumi0r
        r1=sqrt(r2)*r1
        r2=ksir*abs(sin(delta))*r0
        r1=-sqrt(r2)*r1
        cr1=(0.,-1.)*omega*r/caver
        cr1=cexp(cr1)
        cr1=a1*cr1
        a=cr1/r1
        b(1)=1.
        b(2)=(0.,1.)*sinfi
        b(3)=-(0.,1.)*cosfi
	wr(1)=0.
	wr(2)=b(2)
	wr(3)=b(3)
        der(1,1)=0.
        der(2,1)=vrfs*b(2)
        der(3,1)=vrfs*b(3)
        der(1,2)=0.
        der(2,2)=dvrfs*b(2)
        der(3,2)=dvrfs*b(3)
        der(1,3)=0.
        der(2,3)=d2vrfs*b(2)
        der(3,3)=d2vrfs*b(3)
        der(1,4)=0.
        der(2,4)=d3vrfs*b(2)
        der(3,4)=d3vrfs*b(3)
        b(2)=(0.,1.)*cosfi*ksis
        b(3)=(0.,1.)*sinfi*ksis
                                do 2100 j=1,3
        cr1=a*wr(j)
                                do 2100 k=1,3
        kl=3                               
                                do 2100 l=1,3
                if(l.gt.1) kl=2
                                do 2100 m=1,3
        km=kl
                if(m.gt.1) km=kl-1
                                do 2100 n=1,3
        kn=km
                if(n.gt.1) kn=km-1
c----------------------------------------------------------------------
c       kn - order of derivative with respect to z
c----------------------------------------------------------------------
        kn=kn+1
        g(j,k,l,m,n)=cr1*der(k,kn)*b(l)*b(m)*b(n)
c-----------------------------------------------------------------------
c       At the recorder vfi(0)=1.
c-----------------------------------------------------------------------
2100                                    continue
3000                                    continue
                                                                RETURN
                                                                END
