czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
        Subroutine GREEN2(cs,ugrs,sumi0s,vzs,vrfs,dvzs,dvrfs,d2vzs,
     *  d2vrfs,cr,ugrr,sumi0r,vrr,lr,omega,r,fi,caver,g)
czzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz
c-----------------------------------------------------------------------
c       Program calculates g(j,k,l,m) - the 2-nd derivative of Green
c       function spectrum G(j,k) for Rayleigh (or Love) mode of a given
c       frequency 'omega'. l,m=1 - derivation with respect to z,
c       l,m=2 - to x, l,m=3 - to y.
c       Index s - source, index r - receiver.
c       c - phase velocities; ugr - group velocities; sumi0 - I0;
c       vz,vrf - z and r (or fi) components of eigenfunction;
c       dvzs,dvrfs,d2vzs,d2vrfs - derivatives of eigenfunctions at the
c       source with respect to z; lr - if lr=0, then Love waves will
c       be calculated, else - Rayleigh waves; omega - circle frequency;
c       r - length of the ray; fi - azimuth of receiver;
c       caver - average phase velocity along the ray;
c       g - complex array g(3,3,3,3) - result of program.
c-----------------------------------------------------------------------
        real*4 ksis,ksir
        complex g(3,3,3,3),a,a1,b(3),dws(3,3,3),wr(3),dvf(3,3),cr1
        pi=3.141592
        r0=6371.
        delta=r/r0
        r1=3.*2.*pi*cs/omega
c                        if(abs(20015.-r).gt.r1) go to 1
c        print*,'distant',r,'km      is  too close to the antiepicentre'
c                                                        STOP
c1                                       continue
        r1=1/(8.*pi)
        r1=sqrt(r1)
        r2=pi/4.
        cr1=(0.,-1.)*r2
        cr1=cexp(cr1)
        a1=cr1*r1
        sinfi=sin(fi)
        cosfi=cos(fi)
                        if(lr.eq.0)             go to 2000
c-----------------------------------------------------------------------
c       Rayleigh waves calculations
c-----------------------------------------------------------------------
        ksis=omega/cs
        ksir=omega/cr
        r1=cs*ugrs*sumi0s
        r1=sqrt(r1)
        r2=cr*ugrr*sumi0r
        r1=sqrt(r2)*r1
        r2=ksir*abs(sin(delta))*r0
        r1=sqrt(r2)*r1
        cr1=(0.,-1.)*omega*r/caver
        cr1=cexp(cr1)
        cr1=a1*cr1
        a=cr1/r1
        b(1)=1.
        b(2)=(0.,1.)*cosfi
        b(3)=(0.,1.)*sinfi
        wr(1)=1.
        wr(2)=vrr*b(2)
        wr(3)=vrr*b(3)
        dws(1,1,1)=d2vzs
        dws(1,1,2)=dvzs*ksis*b(2)
        dws(1,1,3)=dvzs*ksis*b(3)
        r1=ksis*ksis*vzs
        r2=ksis*dvzs
        dws(1,2,1)=r2*b(2)
        dws(1,2,2)=r1*b(2)*b(2)
        dws(1,2,3)=r1*b(2)*b(3)
        dws(1,3,1)=r2*b(3)
        dws(1,3,2)=r1*b(3)*b(2)
        dws(1,3,3)=r1*b(3)*b(3)
        dws(2,1,1)=d2vrfs*b(2)
        dws(2,1,2)=dvrfs*b(2)*ksis*b(2)
        dws(2,1,3)=dvrfs*b(2)*ksis*b(3)
        r1=ksis*ksis*vrfs
        r2=ksis*dvrfs
        dws(2,2,1)=r2*b(2)*b(2)
        dws(2,2,2)=r1*b(2)*b(2)*b(2)
        dws(2,2,3)=r1*b(2)*b(2)*b(3)
        dws(2,3,1)=r2*b(3)*b(2)
        dws(2,3,2)=r1*b(3)*b(2)*b(2)
        dws(2,3,3)=r1*b(3)*b(2)*b(3)
        dws(3,1,1)=d2vrfs*b(3)
        dws(3,1,2)=dvrfs*b(3)*ksis*b(2)
        dws(3,1,3)=dvrfs*b(3)*ksis*b(3)
        dws(3,2,1)=r2*b(2)*b(3)
        dws(3,2,3)=r1*b(2)*b(3)*b(2)
        dws(3,2,3)=r1*b(2)*b(3)*b(3)
        dws(3,3,1)=r2*b(3)*b(3)
        dws(3,3,2)=r1*b(3)*b(3)*b(2)
        dws(3,3,3)=r1*b(3)*b(3)*b(3)
                                do 1100 j=1,3
        j1=j*(j-1)/2
        jj=(-1)**j1
        cr1=a*wr(j)*jj
                                do 1100 k=1,3
                                do 1100 l=1,3
                                do 1100 m=1,3
        g(j,k,l,m)=cr1*dws(k,l,m)
1100                                    continue
                                                        go to 3000
c-----------------------------------------------------------------------
c       Love waves calculations
c-----------------------------------------------------------------------
2000    ksis=omega/cs
        ksir=omega/cr
        r1=cs*ugrs*sumi0s
        r1=sqrt(r1)
        r2=cr*ugrr*sumi0r
        r1=sqrt(r2)*r1
        r2=ksir*abs(sin(delta))*r0
        r1=-sqrt(r2)*r1
        cr1=(0.,-1.)*omega*r/caver
        cr1=cexp(cr1)
        cr1=a1*cr1
        a=cr1/r1
        b(1)=0.
        b(2)=(0.,1.)*sinfi
        b(3)=-(0.,1.)*cosfi
        r1=dvrfs*ksis
        dvf(1,1)=d2vrfs
        dvf(1,2)=(0.,1.)*r1*cosfi
        dvf(1,3)=(0.,1.)*r1*sinfi
        r1=vrfs*ksis*cosfi*ksis
        r2=dvrfs*ksis*cosfi
        dvf(2,1)=(0.,1.)*r2
        dvf(2,2)=-r1*cosfi
        dvf(2,3)=-r1*sinfi
        r1=vrfs*ksis*sinfi*ksis
        r2=dvrfs*ksis*sinfi
        dvf(3,1)=(0.,1.)*r2
        dvf(3,2)=-r1*cosfi
        dvf(3,3)=-r1*sinfi
                                do 2100 j=1,3
                                do 2100 k=1,3
                                do 2100 l=1,3
                                do 2100 m=1,3
        g(j,k,l,m)=a*b(j)*b(k)*dvf(l,m)
c-----------------------------------------------------------------------
c       At the recorder vfi(0)=1.
c-----------------------------------------------------------------------
2100                                    continue
3000                                    continue
                                                                RETURN
                                                                END
