#include "SpPrcmdw.h"	// our header
#include "bulletin.h"	// our header

#include <v/vnotice.h>	// for vNoticeDialog
int	CheckDirAndEnter(char* dirName,char* OutErr);

int SpePrepCmdWindow::OnCreatePolarityData(char *ErrorReturnCode) 
{ 
char sysString[128];

if (indPolarityScheme == 0) {
fprintf(stderr,"Data polarity source is bulletin.\n");

	if ( GetPolaritiesFromBulletin(ErrorReturnCode) ) return 1;
	
	
}
if (indPolarityScheme == 1) {
fprintf(stderr,"Supplementary data polarity source.\n");
     sprintf(sysString,"cp ../../POLAR/polarity.sup ../../POLAR/polarity.ori");
        system(sysString);


}
if (indPolarityScheme == 2) {
fprintf(stderr,"Polarity source is bulletin plus supplementary data.\n");
	if ( GetPolaritiesFromBulletin(ErrorReturnCode) ) return 1;
}


return 0;
}

int SpePrepCmdWindow::GetPolaritiesFromBulletin(char *ErrorReturnCode) {
	char bulletinInFileName[254];
        char bulletinOutFileName[254];
        char jobProtocolFileName[254];
strcpy(bulletinInFileName,"../../POLAR/bulletin");
strcpy(bulletinOutFileName,"../../POLAR/polarity.ori");
strcpy(jobProtocolFileName,"../../POLAR/bulletin.protocol");
	FILE *prot; // protocol file for info and errors.
        int returnCode;
	if( (prot  = fopen(jobProtocolFileName, "w" )) == NULL ) {
	     fprintf(stderr, "Fatal Error: The protocol file '%s' was not opened:\n",

	jobProtocolFileName);
	     sprintf(ErrorReturnCode, "Fatal Error: The protocol file '%s' was not opened",

	jobProtocolFileName);

	   return 1;}


  SET_SEI *ps = pCDbeSeis->ps;

   SEI **WFSEI = ps->sei;
   SEI *wf;
     wf = WFSEI[0];
float depth = wf->depth;

	if ( (returnCode=TransformFunction(prot,bulletinInFileName,bulletinOutFileName,depth,ErrorReturnCode))){
	fprintf(prot, "Fatal Error: Bulletin transformation was not completed.\n" );
	sprintf(ErrorReturnCode, "Fatal Error: Bulletin transformation was not completed." );
	    return 1;
	}
	else {
	fprintf(prot,   "Info: Bulletin transformation was completed.\n" );
	fprintf(stderr, "Info: Bulletin transformation was completed.\n" );
}

 	fclose(prot);

return 0;
}
int 
SpePrepCmdWindow::TransformFunction(FILE *prot,char* bulletinInFileName,
		             char* bulletinOutFileName,
			     float depth,char *ErrorReturnCode)
{
	int errReadingEpicentreCode,errReadingStationCode;
	FILE *inbul, *outbul;
        /* Open for read */
	if( (inbul  = fopen(bulletinInFileName, "r" )) == NULL ) {
	   fprintf( stderr,"Fatal Error: The file '%s' was not opened: %s\n",bulletinInFileName );
	   fprintf(prot, "Fatal Error: The file '%s' was not opened: %s\n",bulletinInFileName);
	   
	   return 1;}

	/* Open for write */
    if( (outbul = fopen( bulletinOutFileName, "w" )) == NULL ) {
	   printf( "Fatal Error: The file '%s' was not opened\n",bulletinOutFileName );  
	   fprintf(prot, "Fatal Error: The file '%s' was not opened\n",bulletinOutFileName );  
	   return 1;
	}
    
	fprintf(prot, "Info: Job '%s' -> '%s' started.\n", 
	bulletinInFileName,bulletinOutFileName ); 
	fprintf(stderr, "\nInfo: Job '%s' -> '%s'  started.\n",
	bulletinInFileName,bulletinOutFileName ); 

	 	Bulletin * bul;	
	bul = new Mchedr;


		if ( (errReadingEpicentreCode = bul->ReadEpicentre(inbul) )) 
			{
 			switch(errReadingEpicentreCode){
			case ErrorRead:
				{
				fprintf(prot, "Fatal Error:  Error reading  Epicentre  \n");

				break;
				}

			case ErrorFormat:
				{
				fprintf (prot,"Fatal Error: Information of Epicentre was not completed\n");

				break;
				}

			case EofFind:
				{
				fprintf (prot,"Fatal Error: EndOfFile found when Epicentre read.\n");
				
				break;
				}
			case ReadEpicentreComplete:
				{
				fprintf (prot,"Info: Epicentre was read.\n");
				
				break;
				}

		   
		   }


		}
  if ( errReadingEpicentreCode == ReadEpicentreComplete ){
	fprintf(stderr,"Info: Epicentre Information is read.\n");

		if ( (errReadingStationCode = bul->ReadStation(inbul) )) 
			{
 			switch(errReadingStationCode){
			case ErrorRead:
				{
				fprintf(prot, "Fatal Error:  Error reading  Station  \n");

				break;
				}

			case ErrorFormat:
				{
				fprintf (prot,"Fatal Error: Information of Station was not completed\n");

				break;
				}

			case EofFind:
				{
				fprintf (prot,"Error: EndOfFile found when Station read.\nNothing First Motion Information\n");
				
				break;
				}
			case ReadStationComplete:
				{
				fprintf (prot,"Info: Stations Information was read.\n");
				
				break;
				}

		   
		   }


		}


	    if (CheckDirAndEnter("/opt/fmt/KennetTables",
			ErrorReturnCode)) return 1;


 	if ( errReadingStationCode == ReadStationComplete ){
	fprintf(stderr,"Info: Stations Information is read.\n");
	bul->WriteFirstMotions(outbul,prot,depth,pWaveVelocityValue);
        bul->StatisticFMotion(bulletinInFileName,prot);


	}

          if (CheckDirAndEnter(m_WorkDir,ErrorReturnCode)) return 1;
 

} //if ( errReadingEpicentreCode == ReadEpicentreComplete ) 
	fprintf(stderr, "Info: Job '%s' -> '%s' finished.\n",
	bulletinInFileName,bulletinOutFileName ); 

	fprintf(prot, "Info: Job '%s' -> '%s' finished.\n",
	bulletinInFileName,bulletinOutFileName ); 
delete bul;
if (indPolarityScheme == 2) {
char supNameFile[256];
char line[128];
sprintf(supNameFile,"%s/POLAR/polarity.sup",m_WorkDir);
fprintf(stderr,"Supplementary polarity file: > \n'%s'\n",supNameFile);
    FILE *in; 
                if( (in = fopen(supNameFile,"r")) == 0) { // file is not  exist
     sprintf(ErrorReturnCode,"Supplementary Polary File '%s' does not exist.",supNameFile);	    
return 1;
} 

	while (!feof(in)) {
	fgets(line,256,in);
	fputs(line,outbul);

	}
          fclose(in); 


} // indPolarityScheme == 2

	fclose(inbul);fclose(outbul);
	return 0;
}
