//	SpPrcmdw.h:	Header for SpePrepcmdw class
//=======================================================================

#ifndef SpePrepCMDW_H
#define SpePrepCMDW_H
const int _MAX_FILE_NAME  = 200;
#include <v/vcmdwin.h>	// So we can use vCmdWindow
#include <v/vmenu.h>	// For the menu pane
#include <v/vutil.h>	// For V Utilities
#include <v/vcmdpane.h> // command pane
#include <v/vstatusp.h>	// For the status pane
#include <v/vtimer.h>	// Timer
#include <v/vfilesel.h>
#include <v/vcolor.h>
#include <v/vpen.h>
#include <v/vmodald.h>

#include "SpPrdbe.h"    // Dbe 
#include "seis.h"

#include "SpPrcnv.h"	// SpePrepTextCanvasPane
#include "Depthmdlg.h"	// SpePrepDialog
#include "SpPrmdlg.h"	// SpePrepModalDialog
#include "Spdlgrng.h"	// SpePrepModalDialog
#include "polarydlg.h" // Polary Dialog
#include "SpeDbname.h"  // SpeDbNameModaldialog
#include "cmodel.h"
#include "SpPrSave.h"
#include "Sperecdl.h"
#include "ViewPs.h"
#include "Resview.h"
#include "Infomdlg.h"
const char _IND_3SMAC_[] = "3Smac";

// 
void Delete2DCharArray(int numberString,char **&Char2DArray);
void sort(int ,char ** ) ;
void StrToUpper(char *);
void StrToLower(char *);
int Is_Digit(char *);
int Is_ZDigit(char *);
    static int NewfilterIndex = 1;


    static char* Newfilter[] =
      {
            "*",
            "*.wfdisc",
            "*.wfdisc;*.instrument;*.site;*.sensor;*.origin",
        0
      };
    static int OpenfilterIndex = 1;
    static char* Openfilter[] =
      {
            "*",
            "*.spr",
            "*.wfdisc;*.instrument;*.site;*.sensor;*.origin",
        0
      };

    static int SavefilterIndex = 1;
    static char* Savefilter[] =
      {
            "*",
            "*.spr",
           "*.wfdisc;*.instrument;*.site;*.sensor;*.origin",
        0
      };

    static int SaveAsfilterIndex = 1;
    static char* SaveAsfilter[] =
      {
            "*",
            "*.spr",              
            "*.wfdisc;*.instrument;*.site;*.sensor;*.origin",
        0
      };


    class SpePrepCmdWindow;

    class SpePrepTimer : public vTimer
      {
      public:		//---------------------------------------- public
	SpePrepTimer(SpePrepCmdWindow* cw) { cmdw = cw; }
	~SpePrepTimer() {}
	virtual void TimerTick();
      private:		//--------------------------------------- private
	SpePrepCmdWindow* cmdw;
      };

    class SpePrepCmdWindow : public vCmdWindow
      {
	friend int AppMain(int, char**);	// allow AppMain access

      public:		//---------------------------------------- public
int Ww,Hh;
	float StartDepth;
        float StepDepth;
        int   N_StepDepth;
float dip0,ddip,strik0,dstrik,slip,dslip,angl,dangl;
int ndip,nstrik,nslip,nangl;
int PT_axes;
float PT_az,PT_dev,PT_min;

int variantDefinitionPolari;
float minimumValuePolari;
int indPolarityScheme;
float pWaveVelocityValue;


   char  Dir_mom_tens[_MAX_FILE_NAME]; 
   char  Dir_result[_MAX_FILE_NAME];
   char  Dir_obs_calc[_MAX_FILE_NAME];
   char  Dir_maps_ps[_MAX_FILE_NAME];
   char  Dir_mecha_ps[_MAX_FILE_NAME];
   char  Dir_depth_ps[_MAX_FILE_NAME];
   char  Dir_obs_calc_ps[_MAX_FILE_NAME];
   char  Dir_polarity_ps[_MAX_FILE_NAME];
   char  Dir_angle_ps[_MAX_FILE_NAME];

char nameSourceModel[12];


   long  PrintCanvNameDef;

	SpePrepCmdWindow(char*, int, int);
	virtual ~SpePrepCmdWindow();
        virtual void CloseWin();

	virtual void WindowCommand(ItemVal id, ItemVal val, CmdType cType);
	virtual void KeyIn(vKey keysym, unsigned int shift);
         int Fill_ModStaList();
         int Fill_RecPeriodList(char *);
         int Fill_RecDescrList(char *);
         void Fill_CombN2NList();
         int Read_RecMod_list(char *);
         void Change_Lists();
          void EmptyProject();
          void DrawMap(char *); 
	  void DbeView(char *);        
	char *GetProjectWfdisc(char *);
      protected:	//--------------------------------------- protected
int  OnCalcSpe(char *ErrorReturnCode);
int  OnCreatePolarityData(char *ErrorReturnCode);
int  GetPolaritiesFromBulletin(char *ErrorReturnCode);
int TransformFunction(FILE *prot,char* bulletinInFileName,
		             char* bulletinOutFileName,
			     float depth,char* ErrorReturnCode);

void  Write_structure(char * , FILE *);
int  Prepare_Memres (char **, int,char * );
int  Prepare_Gl2res (char **, int ,char *);
 int  Read_Seismogram(int *,int,char *,char *);
 int IndexSeisFromRecList(char *);
 void MomTensCalc();
 int ResultVewWnd();
int Get_SpFitParametrs(long,float &,float &,float &,float &,float &,float &);

      private:		//--------------------------------------- private

	// Standard elements
	vMenuPane* SpePrepMenu;		// For the menu bar
	SpePrepTextCanvasPane* SpePrepCanvas;		// For the canvas
        
	vCommandPane* SpePrepCmdPane;	// for the command pane
        vCommandPane* SpePrepCmdPane2;	// for the command pane
        vCommandPane* SpePrepCmdPane3;	// for the command pane

        
	vStatusPane* SpePrepStatus;		// For the status bar
	SpePrepTimer* _timer;	// Timer for Date/Time

	// Dialogs associated with CmdWindow
	SpPrDepthModalDialog*  SpPrDepthDlg;
		SpResViewMdlg * SpResViewDlg;
                InfoViewMDlg* pInfoViewMDlg;
	//SpePrepDialog* SpePrepDlg;
	SpePrepModalDialog* SpePrepMDlg;
        SpePrepMDRange* SpePrepMDR;
        SpDbNameModalDialog*  SpeDbNameDialog;
        CRecordDialog* SpRecordMDialog;
					ViewPsDialog* SpViewPsMDialog;

	PolaryModalDialog* SpPolaryDialog;

         // Dbase associated with CmdWindow
         CDbeSeis *pCDbeSeis;
         _MLTM    *pMod;    
          CSpPrSave  *pSpPrSave; 


   char CSpPrSaveName[256];  
char m_Comment[128];          
char m_WorkDir[_MAX_FILE_NAME];
char m_ResultDir[_MAX_FILE_NAME];
int Control;
int  N_ModStaList,N_StaList,N_ModList;
char ** ModStaList;
char ** StaList;
char ** ModList;
char ** RecordList; // Records in WFdisc
char ** RecordInList; // Records in Project
int  N_RecPeriodList,N_RecDescrList,N_CombN2NList,N_RecordList,N_RecordInList;
char ** RecPeriodList;
char ** RecDescrList;
char **CombN2NList;
     float PhVelTmin;
     float ComTmin;
     float CorrComTmin;
     float ComTmax;
     float CorrComTmax;
     int   NPoints;
     int   TotalNum;
     long  N2N;
     int   PhVelCheck;

char **DrawList;
        float   m_dt;
        float   m_dw; 
        int m_nitems;
	float * m_w_min;  
	float * m_w_max;   
	float * m_t_min;  
	float * m_t_max;	 
	float * m_dw0; 
	int   * m_ipoint; 
////// SpeCalc  ////////////////////////////////////////
	long	m_nff; 
	long	m_npoints; 
	float	m_tmax; 
	float	m_tmax_com; 
	float	m_tmin; 
	float	m_tmin_com; 
	//CString	m_list_range; 
	//String	m_list_w; 
	//CString	m_list_sign;  
		//CString	m_kennet_angles_list; 
		long      mipoint; 
		long      mnsample; 
		float     mt0; 
		float     mdt; 
		long      micomp; 
		char      mlr; 
                float	  mtmax; 
		float	  mtmin;		 
		char      mlrfile[8]; 
		long      mcode_return; 
		float	  m_tmin_com_e; 
		float	  m_tmax_com_e;  
		int       m_phvcheck; 
		float     m_phvmax; 
int * FindSeiIndex;
int EnablePolari;
int EnableMomTens;
 int IdicateDoubles;

      };
#endif
