//
// C++ Interface: creationdb
//
// Description:
//
//
// Author: fmt <fmt@localhost.localdomain>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef APPLICATION_KONSOLE_H
#define APPLICATION_KONSOLE_H
#include <QTextEdit>
#include <QProcess>
class MDocument;
class ProcessKonsole;
class AppKonsole : public QTextEdit {
    Q_OBJECT
public:
    AppKonsole(QWidget* parent);
    ~AppKonsole();
    void SetDateTimeKonsole(MDocument* doc);
    void SetStandardOutput(const QByteArray & outputArray);
    bool PolaritySmoothingProcess(const QString & program, const QString & workingDirectory,const QStringList & arguments,float depth,float vpsource,float an);
    bool Get3SmacModels();
public slots:
protected:
protected slots:
private:
    MDocument* doc;
    ProcessKonsole* proc;
};

class ProcessKonsole : public QProcess {
    Q_OBJECT
public:
    enum ProcessType {
        Polarity,
        SeedToAh,
        AhToDb,
        DbDecimate
    };

    ProcessKonsole(QWidget* parent,ProcessType type);
    ~ProcessKonsole();
    bool StartProcess(const QString & name,const QString & program, const QString & workingDirectory,const QStringList & arguments);
    ProcessType GetProcessType() {
        return type;
    }
public slots:
protected:
protected slots:
    void ReadStandardOutput();
    void ReadStandardError();
    void ReadyRead();

private:
    QWidget* parent;
    ProcessType type;
    QString program;
};


#endif



