#include <QString>
#include <QVector>
#include <QDir>
#include <QStringList>
#include <float.h>

extern QString M0MTENS_ROOT_PATH;
extern QString M0MTENS_SEARCH_HELP_PATH;


static const  QString USER_HOME_PATH = QDir::homePath();

const QString  userHomePath()               { return USER_HOME_PATH;}

const QString  rootPath()                  { return M0MTENS_ROOT_PATH;}
const QString  searchHelpPath()            { return M0MTENS_SEARCH_HELP_PATH;}

static const  QString MAIN_WINDOW_CAPTION = "Moment Tensor";
const QString  mainWindowCaption()                  { return MAIN_WINDOW_CAPTION; }

static const  QString TEMPORARY_SYSTEM_DIRECTORY_PATH = QDir::temp().absolutePath ();
const QString  temporarySystemDirectoryPath()    { return TEMPORARY_SYSTEM_DIRECTORY_PATH; }

static const QString TEMPORARY_DIRECTORY_PREFIX    = "momTens-";
const QString  temporaryDirectoryPrifix()    { return TEMPORARY_DIRECTORY_PREFIX; }

static const  QString AH_FILE_FILTER_LOCATOR = ".ah";
const QString ahFilterLocator()   { return AH_FILE_FILTER_LOCATOR; }


static const  QString MODEL_FILE_FILTER_LOCATOR = ".mod";
const QString modelFilterLocator()   { return MODEL_FILE_FILTER_LOCATOR; }

static const QString OPEN_AH_FILTERS = "Seis ah files (*.ah);;Any files (*)";
const QString openAhFilters()     { return OPEN_AH_FILTERS;}

static const  QString PROJECT_FILE_FILTER_LOCATOR = ".momtenspro";
const QString projectFileFilterLocator()  { return PROJECT_FILE_FILTER_LOCATOR;}  

static const QString OPEN_PROJECT_FILTERS = 
"P-invers project files (*" + 
PROJECT_FILE_FILTER_LOCATOR+
");;Any files (*)";
const QString openProjectFilters()     { return OPEN_PROJECT_FILTERS;}

static const  QString PROJECT_BINARY_FILE_NAME = "parametrs.bin";
const QString projectBinaryFileName()  { return PROJECT_BINARY_FILE_NAME;}


static const  QString POLARITY_FILE_FILTER_LOCATOR = ".sup";
const QString polarityFilterLocator()   { return POLARITY_FILE_FILTER_LOCATOR; }

static const QString PORARITY_FILE_FILTERS = 
"Polarity files (*" + 
POLARITY_FILE_FILTER_LOCATOR +
");;Any files (*)";
const QString polarityFilters()     { return PORARITY_FILE_FILTERS;}

static const  QString BULLETIN_FILE_FILTER_LOCATOR = ".bul";
const QString buletinFilterLocator()   { return BULLETIN_FILE_FILTER_LOCATOR; }

static const QString BULLETIN_FILE_FILTERS = 
"Polarity files (*" + 
BULLETIN_FILE_FILTER_LOCATOR +
");;Any files (*)";
const QString buletinFilters()     { return BULLETIN_FILE_FILTERS;}
///------------- QDataStream version read-write constants : ------------------------------------------- 
static const  QString  Fmt_Current_Version = "111"; 
static const  QString  Fmt_Versions_For_Qt_4 = "110 120";
 
const QString  FmtCurrentVersion()                  { return Fmt_Current_Version;                   }

const QString  FmtVersionsForQt_4()                 { return  Fmt_Versions_For_Qt_4;               }
///------------- QDataStream version read-write constants : ------------------------------------------- 

  
///---------------PROJECT DOCUMENT PARAMETERS ----------------------------------
static const QString    MOMTENS_INDICATOR_DEFAULT_SPACE       = "Space";
const QString  indicatorDefaultSpace()          { return MOMTENS_INDICATOR_DEFAULT_SPACE;          }
///----------------------------------------- Priority List Values   ----------------------------------------
static const QString FMT_BOOL_LIST_ENUM           = "False True";
const QString enumBoolList()     { return FMT_BOOL_LIST_ENUM;    }

//      Additional parameters for Pinv_Current_Version = "110";

///----------------------------------- Siesmograms -----------------------------

static const int     FMT_LIST_SEIS_ID               = 1;
static const QString FMT_LIST_SEIS_DEFAULT          = QString();
static const QString FMT_LIST_SEIS_NAME             = "Seis List";
int     idListSies()       { return FMT_LIST_SEIS_ID; }
const QString defaultListSies()  { return FMT_LIST_SEIS_DEFAULT; }
const QString nameListSies()     { return FMT_LIST_SEIS_NAME; }

///-------------------------- InList Name Sies -------------------------------------
static const int     FMT_INLIST_NAME_SEIS_ID               = 2;
static const QString FMT_INLIST_NAME_SEIS_DEFAULT          = QString();
static const QString FMT_INLIST_NAME_SEIS_NAME             = "Seis Name List";
int     idInListNameSies()       { return FMT_INLIST_NAME_SEIS_ID; }
const QString defaultInListNameSies()  { return FMT_INLIST_NAME_SEIS_DEFAULT; }
const QString nameInListNameSies()     { return FMT_INLIST_NAME_SEIS_NAME; }


/// List :> 0 - not selected    1 - selected
static const int     FMT_LIST_SELECTD_INDEX_ID               = 3;
static const QString FMT_LIST_SELECTD_INDEX_DEFAULT          = QString();
static const QString FMT_LIST_SELECTD_INDEX_NAME             = "Index List";
int     idListIndexes()       { return FMT_LIST_SELECTD_INDEX_ID;      }
const QString defaultListIndexes()  { return FMT_LIST_SELECTD_INDEX_DEFAULT; }
const QString nameListIndexes()     { return FMT_LIST_SELECTD_INDEX_NAME;     }

///----------------------------------- Input Data Directory Name --------------------------
static const int     DATA_DIRECTORY_NAME_ID         = 4;
static const QString DATA_DIRECTORY_NAME                      = "Input Directory Name";
static const QString DATA_DIRECTORY_NAME_DEFAULT               = QString();
int     idDataDirectoryName()       { return DATA_DIRECTORY_NAME_ID;      }
const QString nameDataDirectoryName()     { return DATA_DIRECTORY_NAME;         }
const QString defaultDataDirectoryName()  { return DATA_DIRECTORY_NAME_DEFAULT; }

///----------------------------------- Is Ftan Project  -----------------------------
static const int     IS_FTAN_PROJECT_ID               = 5;
static const QString IS_FTAN_PROJECT                      = "Is Pro Ftan?";
static const QString IS_FTAN_PROJECT_DEFAULT               = "True";
int     idIsFtanProject()       { return IS_FTAN_PROJECT_ID;      }
const QString nameIsFtanProject()     { return IS_FTAN_PROJECT;         }
const QString defaultIsFtanProject()  { return IS_FTAN_PROJECT_DEFAULT; }

///------------------------- Model Panel ------------------------------------------

///------------------------- Model Directory  -------------------------------------
static const int     MODEL_DIRECTORY_NAME_ID         = 6;
static const QString MODEL_DIRECTORY_NAME                      = "Model Directory Name";
static const QString DMODEL_DIRECTORY_NAME_DEFAULT               = QString();
int     idModelDirectoryName()       { return MODEL_DIRECTORY_NAME_ID;      }
const QString nameModelDirectoryName()     { return MODEL_DIRECTORY_NAME;         }
const QString defaultModelDirectoryName()  { return DMODEL_DIRECTORY_NAME_DEFAULT; }

///------------------------- Station Name List ------------------------------------
static const int     FMT_STATION_NAME_LIST_ID               = 7;
static const QString FMT_STATION_NAME_LIST_DEFAULT          = QString();
static const QString FMT_STATION_NAME_LIST_NAME             = "Sta Name List";
int     idStationNameList()       { return FMT_STATION_NAME_LIST_ID; }
const QString defaultStationNameList()  { return FMT_STATION_NAME_LIST_DEFAULT; }
const QString nameStationNameList()     { return FMT_STATION_NAME_LIST_NAME; }

///------------------------- Sation Model List ------------------------------------
static const int     FMT_STATION_MODEL_LIST_ID               = 8;
static const QString FMT_STATION_MODEL_LIST_DEFAULT          = QString();
static const QString FMT_STATION_MODEL_LIST_NAME             = "Sta Name List";
int     idStationModelList()       { return FMT_STATION_MODEL_LIST_ID; }
const QString defaultStationModelList()  { return FMT_STATION_MODEL_LIST_DEFAULT; }
const QString nameStationModelList()     { return FMT_STATION_MODEL_LIST_NAME; }

///------------------------- Source Model Type -------------------------------------
static const int     FMT_SOURCE_MODEL_ID               = 9;
static const QString FMT_SOURCE_MODEL_NAME             = "Source Model";
static const QString FMT_SOURCE_MODEL_DEFAULT          = "0";
static const QString FMT_SOURCE_MODEL_ENUM             = "3Smac ModelList";
int     idSourceModelType()       { return FMT_SOURCE_MODEL_ID;      }
const QString nameSourceModelType()     { return FMT_SOURCE_MODEL_NAME;    }
const QString defaultSourceModelType()  { return FMT_SOURCE_MODEL_DEFAULT; }
const QString enumSourceModelType()     { return FMT_SOURCE_MODEL_ENUM;    }

///------------------------- Source Model Name -------------------------------------
static const int     NAME_SOURCE_MODEL_ID         = 10;
static const QString NAME_SOURCE_MODEL_NAME                      = "Source Model Name";
static const QString NAME_SOURCE_MODEL_DEFAULT               = "3Smac";
int     idNameSourceModel()       { return NAME_SOURCE_MODEL_ID;      }
const QString nameNameSourceModel()     { return NAME_SOURCE_MODEL_NAME;         }
const QString defaultNameSourceModel()  { return NAME_SOURCE_MODEL_DEFAULT; }

///------------------------- Range Panel --------------------------------------------

///------------------------- TMinRangeWave -------------------------------------

static const int        FMT_TMIN_RANGE_WAVE_ID               = 11; 
static const QString    FMT_TMIN_RANGE_WAVE_DEFAULT   = "0"  ;
static const QString    FMT_TMIN_RANGE_WAVE                    = "TMinRangeWave";
static const float      FMT_TMIN_RANGE_WAVE_MIN            = 0;
static const float      FMT_TMIN_RANGE_WAVE_MAX           = 1000;
static const int        FMT_TMIN_RANGE_WAVE_DECIMAL    = 2;
int      idTMinRangeWave()            { return FMT_TMIN_RANGE_WAVE_ID;       }
const QString  defaultTMinRangeWave()       { return FMT_TMIN_RANGE_WAVE_DEFAULT;  }
const QString  nameTMinRangeWave()          { return FMT_TMIN_RANGE_WAVE;          }
float    minTMinRangeWave()           { return FMT_TMIN_RANGE_WAVE_MIN;      }
float    maxTMinRangeWave()           { return FMT_TMIN_RANGE_WAVE_MAX;      }
int      decimalTMinRangeWave()       { return FMT_TMIN_RANGE_WAVE_DECIMAL;  }

///------------------------- TMaxRangeWave -------------------------------------

static const int        FMT_TMAX_RANGE_WAVE_ID               = 12; 
static const QString    FMT_TMAX_RANGE_WAVE_DEFAULT   = "0"  ;
static const QString    FMT_TMAX_RANGE_WAVE                    = "TMaxRangeWave";
static const float      FMT_TMAX_RANGE_WAVE_MIN            = 0;
static const float      FMT_TMAX_RANGE_WAVE_MAX           = 1000;
static const int        FMT_TMAX_RANGE_WAVE_DECIMAL    = 2;
int      idTMaxRangeWave()            { return FMT_TMAX_RANGE_WAVE_ID;       }
const QString  defaultTMaxRangeWave()       { return FMT_TMAX_RANGE_WAVE_DEFAULT;  }
const QString  nameTMaxRangeWave()          { return FMT_TMAX_RANGE_WAVE;          }
float    minTMaxRangeWave()           { return FMT_TMAX_RANGE_WAVE_MIN;      }
float    maxTMaxRangeWave()           { return FMT_TMAX_RANGE_WAVE_MAX;      }
int      decimalTMaxRangeWave()       { return FMT_TMAX_RANGE_WAVE_DECIMAL;  }

///------------------------- PhVel -------------------------------------

static const int     FMT_PH_VEL_ID               = 14;
static const QString FMT_PH_VEL                      = "PhVel";
static const QString FMT_PH_VEL_DEFAULT               = "False";
int     idPhVel()       { return FMT_PH_VEL_ID;      }
const QString namePhVel()     { return FMT_PH_VEL;         }
const QString defaultPhVel()  { return FMT_PH_VEL_DEFAULT; }

///------------------------- TMin -------------------------------------

static const int        FMT_T_MIN_ID               = 15; 
static const QString    FMT_T_MIN_DEFAULT   = "0"  ;
static const QString    FMT_T_MIN                    = "TMin";
static const float      FMT_T_MIN_MIN            = 0;
static const float      FMT_T_MIN_MAX           = 1000;
static const int        FMT_T_MIN_DECIMAL    = 2;
int      idTMin()            { return FMT_T_MIN_ID;       }
const QString  defaultTMin()       { return FMT_T_MIN_DEFAULT;  }
const QString  nameTMin()          { return FMT_T_MIN;          }
float    minTMin()           { return FMT_T_MIN_MIN;      }
float    maxTMin()           { return FMT_T_MIN_MAX;      }
int      decimalTMin()       { return FMT_T_MIN_DECIMAL;  }

///------------------------- RangeWaveList -------------------------------------

static const int     FMT_RANGE_WAVE_LIST_ID               = 16;
static const QString FMT_RANGE_WAVE_LIST_DEFAULT          = QString();
static const QString FMT_RANGE_WAVE_LIST                  = "RangeWaveList";
int     idRangeWaveList()       { return FMT_RANGE_WAVE_LIST_ID; }
const QString defaultRangeWaveList()  { return FMT_RANGE_WAVE_LIST_DEFAULT; }
const QString nameRangeWaveList()     { return FMT_RANGE_WAVE_LIST; }


///------------------------- TMinRangeGridRangeGrid -------------------------------------

static const int        FMT_T_MIN_RANGE_GRID_ID               = 17; 
static const QString    FMT_T_MIN_RANGE_GRID_DEFAULT   = "0"  ;
static const QString    FMT_T_MIN_RANGE_GRID                    = "TMinRangeGrid";
static const float      FMT_T_MIN_RANGE_GRID_MIN            = 0;
static const float      FMT_T_MIN_RANGE_GRID_MAX           = 1000;
static const int        FMT_T_MIN_RANGE_GRID_DECIMAL    = 2;
int      idTMinRangeGrid()            { return FMT_T_MIN_RANGE_GRID_ID;       }
const QString  defaultTMinRangeGrid()       { return FMT_T_MIN_RANGE_GRID_DEFAULT;  }
const QString  nameTMinRangeGrid()          { return FMT_T_MIN_RANGE_GRID;          }
float    minTMinRangeGrid()           { return FMT_T_MIN_RANGE_GRID_MIN;      }
float    maxTMinRangeGrid()           { return FMT_T_MIN_RANGE_GRID_MAX;      }
int      decimalTMinRangeGrid()       { return FMT_T_MIN_RANGE_GRID_DECIMAL;  }

///------------------------- TMaxRangeGrid -------------------------------------

static const int        FMT_T_MAX_RANGE_GRID_ID               = 18; 
static const QString    FMT_T_MAX_RANGE_GRID_DEFAULT   = "0"  ;
static const QString    FMT_T_MAX_RANGE_GRID                    = "TMaxRangeGrid";
static const float      FMT_T_MAX_RANGE_GRID_MIN            = 0;
static const float      FMT_T_MAX_RANGE_GRID_MAX           = 1000;
static const int        FMT_T_MAX_RANGE_GRID_DECIMAL    = 2;
int      idTMaxRangeGrid()            { return FMT_T_MAX_RANGE_GRID_ID;       }
const QString  defaultTMaxRangeGrid()       { return FMT_T_MAX_RANGE_GRID_DEFAULT;  }
const QString  nameTMaxRangeGrid()          { return FMT_T_MAX_RANGE_GRID;          }
float    minTMaxRangeGrid()           { return FMT_T_MAX_RANGE_GRID_MIN;      }
float    maxTMaxRangeGrid()           { return FMT_T_MAX_RANGE_GRID_MAX;      }
int      decimalTMaxRangeGrid()       { return FMT_T_MAX_RANGE_GRID_DECIMAL;  }

///------------------------- NumberSamples -------------------------------------

static const int     FMT_NUMBER_SAMPLES_ID              = 19;
static const QString FMT_NUMBER_SAMPLES_DEFAULT         = "12"; 
static const QString FMT_NUMBER_SAMPLES                 = "NumberSamples";
static const int     FMT_NUMBER_SAMPLES_MIN             = 5;
static const int     FMT_NUMBER_SAMPLES_MAX             = 18;
static const bool    FMT_NUMBER_SAMPLES_SIGNED_VALUE    = FALSE;
int            idNumberSamples()       { return FMT_NUMBER_SAMPLES_ID;           }
const QString        defaultNumberSamples()  { return FMT_NUMBER_SAMPLES_DEFAULT;      }
const QString        nameNumberSamples()     { return FMT_NUMBER_SAMPLES;              }
int            minNumberSamples()      { return FMT_NUMBER_SAMPLES_MIN;          }
int            maxNumberSamples()      { return FMT_NUMBER_SAMPLES_MAX;          }
bool           signedNumberSamples()   { return FMT_NUMBER_SAMPLES_SIGNED_VALUE; }

///------------------------- FFT_N2N -------------------------------------

static const int  FMT_FFT_N2N_ID                = 20;
static const QString FMT_FFT_N2N                       = "FFT N2N";
static const QString FMT_FFT_N2N_DEFAULT               = "3";
static const QString FMT_FFT_N2N_ENUM       = "4096@8192@16384@32768@65536";
int idFftn2n()           { return FMT_FFT_N2N_ID;      }
const QString nameFftn2n()     { return FMT_FFT_N2N;         }
const QString defaultFftn2n()  { return FMT_FFT_N2N_DEFAULT; }
const QString enumFftn2n()     { return FMT_FFT_N2N_ENUM;    }

///------------------------- RangeGridList -------------------------------------


static const int     FMT_RANGE_GRID_LIST_ID               = 21;
static const QString FMT_RANGE_GRID_LIST_DEFAULT          = QString();
static const QString FMT_RANGE_GRID_LIST                  = "RangeGridList";
int     idRangeGridList()       { return FMT_RANGE_GRID_LIST_ID;      }
const QString defaultRangeGridList()  { return FMT_RANGE_GRID_LIST_DEFAULT; }
const QString nameRangeGridList()     { return FMT_RANGE_GRID_LIST;         }

///------------------------- Polarity Panel --------------------------------------------

///------------------------- Is polarity suplementary -----------------------------------
static const int     IS_POLARITY_SUPLEMENTARY_ID               = 22;
static const QString IS_POLARITY_SUPLEMENTARY                      = "Is Pol Sup?";
static const QString IS_POLARITY_SUPLEMENTARY_DEFAULT               = "False";
int   idIsPolaritySuplementary()               { return IS_POLARITY_SUPLEMENTARY_ID;      }
const QString nameIsPolaritySuplementary()     { return IS_POLARITY_SUPLEMENTARY;         }
const QString defaultIsPolaritySuplementary()  { return IS_POLARITY_SUPLEMENTARY_DEFAULT; }

///------------------------- Is polarity bulletin -----------------------------------
static const int     IS_POLARITY_BULLETIN_ID               = 23;
static const QString IS_POLARITY_BULLETIN                      = "Is Pol Sup?";
static const QString IS_POLARITY_BULLETIN_DEFAULT               = "False";
int   idIsPolarityBulletin()               { return IS_POLARITY_BULLETIN_ID;      }
const QString nameIsPolarityBulletin()     { return IS_POLARITY_BULLETIN;         }
const QString defaultIsPolarityBulletin()  { return IS_POLARITY_BULLETIN_DEFAULT; }

///------------------------- Supplementary file name  -------------------------------------
static const int     SUPPLEMENTARY_FILE_NAME_ID         = 24;
static const QString SUPPLEMENTARY_FILE_NAME                      = "Sup file Name";
static const QString SUPPLEMENTARY_FILE_NAME_DEFAULT               = QString();
int   idSuplementaryFileName()             { return SUPPLEMENTARY_FILE_NAME_ID;    }
const QString nameSuplementaryFileName()   { return SUPPLEMENTARY_FILE_NAME;       }
const QString defaultSuplementaryFileName()  { return SUPPLEMENTARY_FILE_NAME_DEFAULT; }

///------------------------- Bulletin file name  -------------------------------------
static const int     BULLETIN_FILE_NAME_ID         = 25;
static const QString BULLETIN_FILE_NAME                      = "Bul file Name";
static const QString BULLETIN_FILE_NAME_DEFAULT               = QString();
int   idBulletinFileName()               { return BULLETIN_FILE_NAME_ID;      }
const QString nameBulletinFileName()     { return BULLETIN_FILE_NAME;         }
const QString defaultBulletinFileName()  { return BULLETIN_FILE_NAME_DEFAULT; }


///------------------------- Polarity Polarity Depth  -------------------------------------
static const int        POLARITY_DEPTH_ID            = 26; 
static const QString    POLARITY_DEPTH               = "Depth";
static const QString    POLARITY_DEPTH_DEFAULT       = MOMTENS_INDICATOR_DEFAULT_SPACE;
static const float      POLARITY_DEPTH_MIN           = 0;
static const float      POLARITY_DEPTH_MAX           = 1000;
static const int        POLARITY_DEPTH_DECIMAL       = 1;
int      idPolarityDepth()            { return POLARITY_DEPTH_ID;       }
const QString  namePolarityDepth()          { return POLARITY_DEPTH;          }
const QString  defaultPolarityDepth()       { return POLARITY_DEPTH_DEFAULT;  }
float    minPolarityDepth()           { return POLARITY_DEPTH_MIN;      }
float    maxtPolarityDepth()          { return POLARITY_DEPTH_MAX;      }
int      decimalPolarityDepth()       { return POLARITY_DEPTH_DECIMAL;  }

///------------------------- Polarity Vpsource  -------------------------------------
static const int        POLARITY_VPSOURCE_ID            = 27; 
static const QString    POLARITY_VPSOURCE               = "Vpsource";
static const QString    POLARITY_VPSOURCE_DEFAULT       = MOMTENS_INDICATOR_DEFAULT_SPACE;
static const float      POLARITY_VPSOURCE_MIN           = 0;
static const float      POLARITY_VPSOURCE_MAX           = 20;
static const int        POLARITY_VPSOURCE_DECIMAL       = 2;
int      idPolarityVpsource()            { return POLARITY_VPSOURCE_ID;       }
const QString  namePolarityVpsource()          { return POLARITY_VPSOURCE;          }
const QString  defaultPolarityVpsource()       { return POLARITY_VPSOURCE_DEFAULT;  }
float    minPolarityVpsource()           { return POLARITY_VPSOURCE_MIN;      }
float    maxtPolarityVpsource()          { return POLARITY_VPSOURCE_MAX;      }
int      decimalPolarityVpsource()       { return POLARITY_VPSOURCE_DECIMAL;  }

///----------------------------------------- Smoothing ------------------------ 
static const int        POLARITY_SMOOTHING_ID            = 28; 
static const QString    POLARITY_SMOOTHING               = "Smoothing";
static const QString    POLARITY_SMOOTHING_DEFAULT       = "0.0";
static const float      POLARITY_SMOOTHING_MIN           = 1.0;
static const float      POLARITY_SMOOTHING_MAX           = 90.0;
static const int        POLARITY_SMOOTHING_DECIMAL       = 1;
int      idPolaritySmoothing()            { return POLARITY_SMOOTHING_ID;       }
const QString  namePolaritySmoothing()          { return POLARITY_SMOOTHING;          }
const QString  defaultPolaritySmoothing()       { return POLARITY_SMOOTHING_DEFAULT;  }
float    minPolaritySmoothing()           { return POLARITY_SMOOTHING_MIN;      }
float    maxtPolaritySmoothing()          { return POLARITY_SMOOTHING_MAX;      }
int      decimalPolaritySmoothing()       { return POLARITY_SMOOTHING_DECIMAL;  }

///------------------------- Grid Panel --------------------------------------------

///------------------------- GridDepth -------------------------------------------------
static const int        GRID_DEPTH_ID            = 30; 
static const QString    GRID_DEPTH               = "GridDepth";
static const QString    GRID_DEPTH_DEFAULT       = "0.0";
static const float      GRID_DEPTH_MIN           = 0.0;
static const float      GRID_DEPTH_MAX           = 1000.0;
static const int        GRID_DEPTH_DECIMAL       = 1;
int      idGridDepth()            { return GRID_DEPTH_ID;       }
const QString  defaultGridDepth()       { return GRID_DEPTH_DEFAULT;  }
const QString  nameGridDepth()          { return GRID_DEPTH;          }
float    minGridDepth()           { return GRID_DEPTH_MIN;      }
float    maxtGridDepth()          { return GRID_DEPTH_MAX;      }
int      decimalGridDepth()       { return GRID_DEPTH_DECIMAL;  }

///------------------------- GridDepthStep -------------------------------------------------
static const int        GRID_DEPTHSTEP_ID            = 31; 
static const QString    GRID_DEPTHSTEP               = "GridDepthStep";
static const QString    GRID_DEPTHSTEP_DEFAULT       = "5.0";
static const float      GRID_DEPTHSTEP_MIN           = 0.0;
static const float      GRID_DEPTHSTEP_MAX           = 100.0;
static const int        GRID_DEPTHSTEP_DECIMAL       = 1;
int      idGridDepthStep()            { return GRID_DEPTHSTEP_ID;       }
const QString  defaultGridDepthStep()       { return GRID_DEPTHSTEP_DEFAULT;  }
const QString  nameGridDepthStep()          { return GRID_DEPTHSTEP;          }
float    minGridDepthStep()           { return GRID_DEPTHSTEP_MIN;      }
float    maxtGridDepthStep()          { return GRID_DEPTHSTEP_MAX;      }
int      decimalGridDepthStep()       { return GRID_DEPTHSTEP_DECIMAL;  }

///------------------------- DepthPoint -------------------------------------

static const int     DEPTH_NUMBER_POINT_ID              = 32;
static const QString DEPTH_NUMBER_POINT_DEFAULT         = "10"; 
static const QString DEPTH_NUMBER_POINT                 = "DepthPoints";
static const int     DEPTH_NUMBER_POINT_MIN             = 0;
static const int     DEPTH_NUMBER_POINT_MAX             = 100;
static const bool    DEPTH_NUMBER_POINT_SIGNED_VALUE    = FALSE;
int            idDepthNumberPoint()       { return DEPTH_NUMBER_POINT_ID;           }
const QString  defaultDepthNumberPoint()  { return DEPTH_NUMBER_POINT_DEFAULT;      }
const QString  nameDepthNumberPoint()     { return DEPTH_NUMBER_POINT;              }
int            minDepthNumberPoint()      { return DEPTH_NUMBER_POINT_MIN;          }
int            maxDepthNumberPoint()      { return DEPTH_NUMBER_POINT_MAX;          }
bool           signedDepthNumberPoint()   { return DEPTH_NUMBER_POINT_SIGNED_VALUE; }

///------------------------- GridDip -------------------------------------------------
static const int        GRID_DIP_ID            = 33; 
static const QString    GRID_DIP               = "GridDip";
static const QString    GRID_DIP_DEFAULT       = "10.0";
static const float      GRID_DIP_MIN           = 0.0;
static const float      GRID_DIP_MAX           = 90.0;
static const int        GRID_DIP_DECIMAL       = 1;
int      idGridDip()            { return GRID_DIP_ID;       }
const QString  defaultGridDip()       { return GRID_DIP_DEFAULT;  }
const QString  nameGridDip()          { return GRID_DIP;          }
float    minGridDip()           { return GRID_DIP_MIN;      }
float    maxtGridDip()          { return GRID_DIP_MAX;      }
int      decimalGridDip()       { return GRID_DIP_DECIMAL;  }

///------------------------- GridDipStep -------------------------------------------------
static const int        GRID_DIPSTEP_ID            = 34; 
static const QString    GRID_DIPSTEP               = "GridDipStep";
static const QString    GRID_DIPSTEP_DEFAULT       = "10.0";
static const float      GRID_DIPSTEP_MIN           = 1.0;
static const float      GRID_DIPSTEP_MAX           = 90.0;
static const int        GRID_DIPSTEP_DECIMAL       = 1;
int      idGridDipStep()            { return GRID_DIPSTEP_ID;       }
const QString  defaultGridDipStep()       { return GRID_DIPSTEP_DEFAULT;  }
const QString  nameGridDipStep()          { return GRID_DIPSTEP;          }
float    minGridDipStep()           { return GRID_DIPSTEP_MIN;      }
float    maxtGridDipStep()          { return GRID_DIPSTEP_MAX;      }
int      decimalGridDipStep()       { return GRID_DIPSTEP_DECIMAL;  }

///------------------------- DipPoint -------------------------------------

static const int     DIP_NUMBER_POINT_ID              = 35;
static const QString DIP_NUMBER_POINT_DEFAULT         = "5"; 
static const QString DIP_NUMBER_POINT                 = "DipPoints";
static const int     DIP_NUMBER_POINT_MIN             = 1;
static const int     DIP_NUMBER_POINT_MAX             = 6;
static const bool    DIP_NUMBER_POINT_SIGNED_VALUE    = FALSE;
int            idDipNumberPoint()       { return DIP_NUMBER_POINT_ID;           }
const QString  defaultDipNumberPoint()  { return DIP_NUMBER_POINT_DEFAULT;      }
const QString  nameDipNumberPoint()     { return DIP_NUMBER_POINT;              }
int            minDipNumberPoint()      { return DIP_NUMBER_POINT_MIN;          }
int            maxDipNumberPoint()      { return DIP_NUMBER_POINT_MAX;          }
bool           signedDipNumberPoint()   { return DIP_NUMBER_POINT_SIGNED_VALUE; }

///------------------------- GridStrike -------------------------------------------------
static const int        GRID_STRIKE_ID            = 36; 
static const QString    GRID_STRIKE               = "GridStrike";
static const QString    GRID_STRIKE_DEFAULT       = "0.0";
static const float      GRID_STRIKE_MIN           = 0.0;
static const float      GRID_STRIKE_MAX           = 360.0;
static const int        GRID_STRIKE_DECIMAL       = 1;
int      idGridStrike()            { return GRID_STRIKE_ID;       }
const QString  defaultGridStrike()       { return GRID_STRIKE_DEFAULT;  }
const QString  nameGridStrike()          { return GRID_STRIKE;          }
float    minGridStrike()           { return GRID_STRIKE_MIN;      }
float    maxtGridStrike()          { return GRID_STRIKE_MAX;      }
int      decimalGridStrike()       { return GRID_STRIKE_DECIMAL;  }

///------------------------- GridStrikeStep -------------------------------------------------
static const int        GRID_STRIKESTEP_ID            = 37; 
static const QString    GRID_STRIKESTEP               = "GridStrikeStep";
static const QString    GRID_STRIKESTEP_DEFAULT       = "15.0";
static const float      GRID_STRIKESTEP_MIN           = 1.0;
static const float      GRID_STRIKESTEP_MAX           = 360.0;
static const int        GRID_STRIKESTEP_DECIMAL       = 1;
int      idGridStrikeStep()            { return GRID_STRIKESTEP_ID;       }
const QString  defaultGridStrikeStep()       { return GRID_STRIKESTEP_DEFAULT;  }
const QString  nameGridStrikeStep()          { return GRID_STRIKESTEP;          }
float    minGridStrikeStep()           { return GRID_STRIKESTEP_MIN;      }
float    maxtGridStrikeStep()          { return GRID_STRIKESTEP_MAX;      }
int      decimalGridStrikeStep()       { return GRID_STRIKESTEP_DECIMAL;  }

///------------------------- StrikePoint -------------------------------------

static const int     STRIKE_NUMBER_POINT_ID              = 38;
static const QString STRIKE_NUMBER_POINT_DEFAULT         = "12"; 
static const QString STRIKE_NUMBER_POINT                 = "StrikePoints";
static const int     STRIKE_NUMBER_POINT_MIN             = 1;
static const int     STRIKE_NUMBER_POINT_MAX             = 12;
static const bool    STRIKE_NUMBER_POINT_SIGNED_VALUE    = FALSE;
int            idStrikeNumberPoint()       { return STRIKE_NUMBER_POINT_ID;           }
const QString  defaultStrikeNumberPoint()  { return STRIKE_NUMBER_POINT_DEFAULT;      }
const QString  nameStrikeNumberPoint()     { return STRIKE_NUMBER_POINT;              }
int            minStrikeNumberPoint()      { return STRIKE_NUMBER_POINT_MIN;          }
int            maxStrikeNumberPoint()      { return STRIKE_NUMBER_POINT_MAX;          }
bool           signedStrikeNumberPoint()   { return STRIKE_NUMBER_POINT_SIGNED_VALUE; }

///------------------------- GridSlip -------------------------------------------------
static const int        GRID_SLIP_ID            = 39; 
static const QString    GRID_SLIP               = "GridSlip";
static const QString    GRID_SLIP_DEFAULT       = "0.0";
static const float      GRID_SLIP_MIN           = -180.0;
static const float      GRID_SLIP_MAX           = 180.0;
static const int        GRID_SLIP_DECIMAL       = 1;
const int      idGridSlip()            { return GRID_SLIP_ID;       }
const QString  defaultGridSlip()       { return GRID_SLIP_DEFAULT;  }
const QString  nameGridSlip()          { return GRID_SLIP;          }
const float    minGridSlip()           { return GRID_SLIP_MIN;      }
const float    maxtGridSlip()          { return GRID_SLIP_MAX;      }
const int      decimalGridSlip()       { return GRID_SLIP_DECIMAL;  }

///------------------------- GridSlipStep -------------------------------------------------
static const int        GRID_SLIPSTEP_ID            = 40; 
static const QString    GRID_SLIPSTEP               = "GridSlipStep";
static const QString    GRID_SLIPSTEP_DEFAULT       = "15.0";
static const float      GRID_SLIPSTEP_MIN           = 1.0;
static const float      GRID_SLIPSTEP_MAX           = 180.0;
static const int        GRID_SLIPSTEP_DECIMAL       = 1;
const int      idGridSlipStep()            { return GRID_SLIPSTEP_ID;       }
const QString  defaultGridSlipStep()       { return GRID_SLIPSTEP_DEFAULT;  }
const QString  nameGridSlipStep()          { return GRID_SLIPSTEP;          }
const float    minGridSlipStep()           { return GRID_SLIPSTEP_MIN;      }
const float    maxtGridSlipStep()          { return GRID_SLIPSTEP_MAX;      }
const int      decimalGridSlipStep()       { return GRID_SLIPSTEP_DECIMAL;  }

///------------------------- SlipPoint -------------------------------------

static const int     SLIP_NUMBER_POINT_ID              = 41;
static const QString SLIP_NUMBER_POINT_DEFAULT         = "12"; 
static const QString SLIP_NUMBER_POINT                 = "SlipPoints";
static const int     SLIP_NUMBER_POINT_MIN             = 1;
static const int     SLIP_NUMBER_POINT_MAX             = 12;
static const bool    SLIP_NUMBER_POINT_SIGNED_VALUE    = FALSE;
int            idSlipNumberPoint()       { return SLIP_NUMBER_POINT_ID;           }
const QString  defaultSlipNumberPoint()  { return SLIP_NUMBER_POINT_DEFAULT;      }
const QString  nameSlipNumberPoint()     { return SLIP_NUMBER_POINT;              }
int            minSlipNumberPoint()      { return SLIP_NUMBER_POINT_MIN;          }
int            maxSlipNumberPoint()      { return SLIP_NUMBER_POINT_MAX;          }
bool           signedSlipNumberPoint()   { return SLIP_NUMBER_POINT_SIGNED_VALUE; }


///----------------------------------- Is recalculate materials  -----------------------------
///----------------------------------- Is polarities smoothong  -----------------------------

static const int     IS_POLARITIES_SMOOTHING_ID               = 42;
static const QString IS_POLARITIES_SMOOTHING                      = "Is Pol Smoo ?";
static const QString IS_POLARITIES_SMOOTHING_DEFAULT               = "False";
int     idIsPolaritiesSmoothing()             { return IS_POLARITIES_SMOOTHING_ID;      }
const QString nameIsPolaritiesSmoothing()     { return IS_POLARITIES_SMOOTHING;         }
const QString defaultIsPolaritiesSmoothing()  { return IS_POLARITIES_SMOOTHING_DEFAULT; }

///----------------------------------- Is model calculate  -----------------------------

static const int     IS_MODELS_CALCULATE_ID               = 43;
static const QString IS_MODELS_CALCULATE                      = "Is model calculate?";
static const QString IS_MODELS_CALCULATE_DEFAULT               = "False";
int     idIsModelCalculate()             { return IS_MODELS_CALCULATE_ID;      }
const QString nameIsModelCalculate()     { return IS_MODELS_CALCULATE;         }
const QString defaultIsModelCalculate()  { return IS_MODELS_CALCULATE_DEFAULT; }

///----------------------------------- Is momtens calculate  -----------------------------

static const int     IS_MOMTENS_CALCULATE_ID               = 44;
static const QString IS_MOMTENS_CALCULATE                      = "Is momtens calculate?";
static const QString IS_MOMTENS_CALCULATE_DEFAULT               = "False";
int     idIsMomtensCalculate()             { return IS_MOMTENS_CALCULATE_ID;      }
const QString nameIsMomtensCalculate()     { return IS_MOMTENS_CALCULATE;         }
const QString defaultIsMomtensCalculate()  { return IS_MOMTENS_CALCULATE_DEFAULT; }


