#ifndef _FMT_MOMTENS_DEFAULTS_H
#define _FMT_MOMTENS_DEFAULTS_H

#define intround(x) ((x)>=0?(long)((x)+0.5):(long)((x)-0.5))
const QString userHomePath();

const QString rootPath();
const QString searchHelpPath();
const QString mainWindowCaption();

const QString temporarySystemDirectoryPath();
const QString temporaryDirectoryPrifix();
const QString ahFilterLocator();
const QString modelFilterLocator();
const QString openAhFilters();
const QString polarityFilters();
const QString buletinFilters();
const QString projectFileFilterLocator();
const QString openProjectFilters();

const QString projectBinaryFileName();
///------------- QDataStream version read-write constants : -------------------------------------------

const QString  FmtCurrentVersion();

const QString  FmtVersionsForQt_4();

///---------------PROJECT DOCUMENT PARAMETERS ----------------------------------
const QString  indicatorDefaultSpace();
///--------------------------------- Priority List Values -----------------------
const QString enumBoolList();
///----------------------------------- Siesmograms -----------------------------
int     idListSies();
const QString defaultListSies();
const QString nameListSies();
///-------------------------- InList Name Sies -------------------------------------
int     idInListNameSies();
const QString defaultInListNameSies();
const QString nameInListNameSies();

/// List :> 0 - not selected    1 - selected
int     idListIndexes();
const QString defaultListIndexes();
const QString nameListIndexes();
///----------------------------------- Input Data Directory Name --------------------------
int     idDataDirectoryName();
const QString nameDataDirectoryName();
const QString defaultDataDirectoryName();
///----------------------------------- Is Ftan Project  -----------------------------
int     idIsFtanProject();
const QString nameIsFtanProject();
const QString defaultIsFtanProject();

///------------------------- Model Panel ------------------------------------------

///------------------------- Model Directory  -------------------------------------
int     idModelDirectoryName();
const QString nameModelDirectoryName();
const QString defaultModelDirectoryName();

///------------------------- Station Name List ------------------------------------
int     idStationNameList();
const QString defaultStationNameList();
const QString nameStationNameList();

///------------------------- Sation Model List ------------------------------------
int     idStationModelList();
const QString defaultStationModelList();
const QString nameStationModelList();

///------------------------- Source Model Type -------------------------------------
int     idSourceModelType();
const QString nameSourceModelType();
const QString defaultSourceModelType();
const QString enumSourceModelType();

///------------------------- Source Model  -------------------------------------
int     idNameSourceModel();
const QString nameNameSourceModel();
const QString defaultNameSourceModel();


///------------------------- Range Panel --------------------------------------------

///------------------------- TMinRangeWave -------------------------------------
int      idTMinRangeWave();
const QString  defaultTMinRangeWave();
const QString  nameTMinRangeWave();
float    minTMinRangeWave();
float    maxTMinRangeWave();
int      decimalTMinRangeWave();

///------------------------- TMaxRangeWave -------------------------------------
int      idTMaxRangeWave();
const QString  defaultTMaxRangeWave();
const QString  nameTMaxRangeWave();
float    minTMaxRangeWave();
float    maxTMaxRangeWave();
int      decimalTMaxRangeWave();

///------------------------- PhVel -------------------------------------
int      idPhVel();
const QString  defaultPhVel();
const QString  namePhVel();

///------------------------- TMin -------------------------------------
int      idTMin();
const QString  defaultTMin();
const QString  nameTMin();
float    minTMin();
float    maxTMin();
int      decimalTMin();

///------------------------- RangeWaveList -------------------------------------
int     idRangeWaveList();
const QString defaultRangeWaveList();
const QString nameRangeWaveList();


///------------------------- TMinRangeGridRangeGrid -------------------------------------
int      idTMinRangeGrid();
const QString  defaultTMinRangeGrid();
const QString  nameTMinRangeGrid();
float    minTMinRangeGrid();
float    maxTMinRangeGrid();
int      decimalTMinRangeGrid();

///------------------------- TMaxRangeGrid -------------------------------------
int      idTMaxRangeGrid();
const QString  defaultTMaxRangeGrid();
const QString  nameTMaxRangeGrid();
float    minTMaxRangeGrid();
float    maxTMaxRangeGrid();
int      decimalTMaxRangeGrid();

///------------------------- NumberSamples -------------------------------------
int            idNumberSamples();
const QString        defaultNumberSamples();
const QString        nameNumberSamples();
int            minNumberSamples();
int            maxNumberSamples();
bool           signedNumberSamples();

///------------------------- FFT_N2N -------------------------------------
int idFftn2n();
const QString nameFftn2n();
const QString defaultFftn2n();
const QString enumFftn2n();

///------------------------- RangeGridList -------------------------------------
int     idRangeGridList();
const QString defaultRangeGridList();
const QString nameRangeGridList();

///------------------------- Polarity Panel --------------------------------------------

///------------------------- Is polarity suplementary -----------------------------------
int   idIsPolaritySuplementary();
const QString nameIsPolaritySuplementary();
const QString defaultIsPolaritySuplementary();

///------------------------- Is polarity bulletin -----------------------------------
int   idIsPolarityBulletin();
const QString nameIsPolarityBulletin();
const QString defaultIsPolarityBulletin();

///------------------------- Supplementary file name  -------------------------------------
int   idSuplementaryFileName();
const QString nameSuplementaryFileName();
const QString defaultSuplementaryFileName();

///------------------------- Bulletin file name  -------------------------------------
int   idBulletinFileName();
const QString nameBulletinFileName();
const QString defaultBulletinFileName();

///------------------------- Polarity Polarity Depth  -------------------------------------
int      idPolarityDepth();
const QString  namePolarityDepth();
const QString  defaultPolarityDepth();
float    minPolarityDepth();
float    maxtPolarityDepth();
int      decimalPolarityDepth();

///------------------------- Polarity Vpsource  -------------------------------------
int      idPolarityVpsource();
const QString  namePolarityVpsource();
const QString  defaultPolarityVpsource();
float    minPolarityVpsource();
float    maxtPolarityVpsource();
int      decimalPolarityVpsource();

///----------------------------------------- Smoothing ------------------------ 
int      idPolaritySmoothing();
const QString  namePolaritySmoothing();
const QString  defaultPolaritySmoothing();
float    minPolaritySmoothing();
float    maxtPolaritySmoothing();
int      decimalPolaritySmoothing();

///------------------------- Grid Panel --------------------------------------------

///------------------------- GridDepth -------------------------------------------------
int      idGridDepth();
const QString  defaultGridDepth();
const QString  nameGridDepth();
float    minGridDepth();
float    maxtGridDepth();
int      decimalGridDepth();

///------------------------- GridDepthStep -------------------------------------------------
int      idGridDepthStep();
const QString  defaultGridDepthStep();
const QString  nameGridDepthStep();
float    minGridDepthStep();
float    maxtGridDepthStep();
int      decimalGridDepthStep();

///------------------------- DepthPoint -------------------------------------

int            idDepthNumberPoint();
const QString  defaultDepthNumberPoint();
const QString  nameDepthNumberPoint();
int            minDepthNumberPoint();
int            maxDepthNumberPoint();
bool           signedDepthNumberPoint();

///------------------------- GridDip -------------------------------------------------
int      idGridDip();
const QString  defaultGridDip();
const QString  nameGridDip();
float    minGridDip();
float    maxtGridDip();
int      decimalGridDip();
///------------------------- GridDipStep -------------------------------------------------
int      idGridDipStep();
const QString  defaultGridDipStep();
const QString  nameGridDipStep();
float    minGridDipStep();
float    maxtGridDipStep();
int      decimalGridDipStep();

///------------------------- DipPoint -------------------------------------
int            idDipNumberPoint();
const QString  defaultDipNumberPoint();
const QString  nameDipNumberPoint();
int            minDipNumberPoint();
int            maxDipNumberPoint();
bool           signedDipNumberPoint();

///------------------------- GridStrike -------------------------------------------------
int      idGridStrike();
const QString  defaultGridStrike();
const QString  nameGridStrike();
float    minGridStrike();
float    maxtGridStrike();
int      decimalGridStrike();
///------------------------- GridStrikeStep -------------------------------------------------
int      idGridStrikeStep();
const QString  defaultGridStrikeStep();
const QString  nameGridStrikeStep();
float    minGridStrikeStep();
float    maxtGridStrikeStep();
int      decimalGridStrikeStep();

///------------------------- StrikePoint -------------------------------------
int            idStrikeNumberPoint();
const QString  defaultStrikeNumberPoint();
const QString  nameStrikeNumberPoint();
int            minStrikeNumberPoint();
int            maxStrikeNumberPoint();
bool           signedStrikeNumberPoint();

///------------------------- GridSlip -------------------------------------------------
int      idGridSlip();
const QString  defaultGridSlip();
const QString  nameGridSlip();
float    minGridSlip();
float    maxtGridSlip();
int      decimalGridSlip();

///------------------------- GridSlipStep -------------------------------------------------
int      idGridSlipStep();
const QString  defaultGridSlipStep();
const QString  nameGridSlipStep();
float    minGridSlipStep();
float    maxtGridSlipStep();
int      decimalGridSlipStep();

///------------------------- SlipPoint -------------------------------------
int            idSlipNumberPoint();
const QString  defaultSlipNumberPoint();
const QString  nameSlipNumberPoint();
int            minSlipNumberPoint();
int            maxSlipNumberPoint();
bool           signedSlipNumberPoint();


///----------------------------------- Is recalculate materials  -----------------------------
///----------------------------------- Is polarities smoothong  -----------------------------
int     idIsPolaritiesSmoothing();
const QString nameIsPolaritiesSmoothing();
const QString defaultIsPolaritiesSmoothing();

///----------------------------------- Is model calculate  -----------------------------
int     idIsModelCalculate();
const QString nameIsModelCalculate();
const QString defaultIsModelCalculate();

///----------------------------------- Is momtens calculate  -----------------------------

int     idIsMomtensCalculate();
const QString nameIsMomtensCalculate();
const QString defaultIsMomtensCalculate();

#endif


