#include <QtGui>

#include "editline.h"
#include "document.h"
#include "default.h"
LineDocProperty::LineDocProperty(QWidget * wd,PropertyValue* pr):
        widget(wd),prop(pr) {

///===================================================================
    if (prop->GetKind()  == PropertyValue::Property_Float) {
        editor = (QLineEdit *) widget;
        editedValue = prop->GetValue();
        PropertyFloatValue * p = (PropertyFloatValue *)prop;
        editor->setValidator(new QDoubleValidator (p->GetMin(),
                             p->GetMax(),p->GetDecimal(), this));
        installEventFilter(editor);
        connect( editor, SIGNAL( textChanged( const QString & ) ),
                 this, SLOT( setValue(const QString &) ) );
        connect( editor, SIGNAL( editingFinished () ),
                 this, SLOT( editFinish() ) );
        connect( editor, SIGNAL( textEdited (const QString &) ),
                 this, SLOT( valueEdited(const QString &) ) );
    }

///====================================================================
    if (prop->GetKind()  == PropertyValue::Property_Int) {
        spin = (QSpinBox *) widget;
        PropertyIntValue * p = (PropertyIntValue *)prop;
        spin->setRange(p->GetMin(),p->GetMax());
//connect( spin->ed, SIGNAL( textEdited (const QString &) ),
//                     this, SLOT( valueEdited(const QString &) ) );

    }

    if (prop->GetKind()  == PropertyValue::Property_IntSpin) {
        spin = (QSpinBox *) widget;
        PropertyIntSpinValue * p = (PropertyIntSpinValue *)prop;
        spin->setRange(p->GetMin(),p->GetMax());
        spin->setSingleStep(p->GetStep());
// connect( spin->ed , SIGNAL( textEdited (const QString &) ),
//                      this, SLOT( valueEdited(const QString &) ) );
    }
}
void LineDocProperty::valueSpinChanged (   ) {
//	QMessageBox::warning(0, "",QString("LineDocProperty::valueSpinChanged"));
//TabDialog::self->SetTabEnabled(false);
}
void LineDocProperty::valueEdited( const QString  & ) {
//TabDialog::self->SetTabEnabled(false);
//QMessageBox::warning(0, "",QString("LineDocProperty::valueEdited"));

}
void LineDocProperty::SetValueFromDoc() {
    if (prop->GetKind()  == PropertyValue::Property_Float) {
        QString tmp = prop->GetValue();
        QString val = "";
        if (tmp == indicatorDefaultSpace())
            val = "";
        else
            val = tmp;


        editor->setText(val);

    }
    if (prop->GetKind()  == PropertyValue::Property_Int) {
        spin->QSpinBox::setValue(prop->GetValue().toInt());
        spin->setValue(prop->GetValue().toInt());
        connect( spin, SIGNAL( valueChanged (const QString &) ),
                 this, SLOT( valueEdited(const QString &) ) );
    }
    if (prop->GetKind()  == PropertyValue::Property_IntSpin) {
        spin->QSpinBox::setValue(prop->GetValue().toInt());
        spin->setValue(prop->GetValue().toInt());
        connect( spin, SIGNAL( valueChanged (const QString &) ),
                 this, SLOT( valueEdited(const QString &) ) );
    }
}
void LineDocProperty::ReplaceProperty(PropertyValue* newprop) {
    if (newprop->GetKind()  == PropertyValue::Property_Float) {
        FinishEditLine();
        prop->SetValue(editor->text());
        PropertyFloatValue* p= (PropertyFloatValue*) newprop;
        QDoubleValidator * vld = (QDoubleValidator*)editor->validator ();
        vld->setRange(p->GetMin(),p->GetMax(),p->GetDecimal());
        SetProp(p);
        editor->setText(newprop->GetValue());
        SetEditedValue(newprop->GetValue());
        SetProp(p);
        editor->setText(p->GetValue());

    }

}


//==================================================================================
void LineDocProperty::editFinish() {
    int pos = 0;
    QString temp = editor->text();
    QString edVal = QString();
    if ( editor->validator()->validate(temp,pos)  != QValidator::Acceptable) {
        editor->setText(editedValue);
        edVal = editedValue;
    } else {
        if (prop->GetKind()  == PropertyValue::Property_Float) {
            bool ok;
            QString tmp = QString("%1").arg(temp.toFloat(&ok));
            if (ok) {
                editor->setText(editor->text());
                edVal = editor->text();
            } else {
                editor->setText(editedValue);
                edVal = editedValue;
            }

        }
        if (prop->GetKind()  == PropertyValue::Property_Int) {
            bool ok;
            QString tmp = QString("%1").arg(temp.toInt(&ok));
            if (ok) {
                editor->setText(editor->text());
                edVal = editor->text();
            } else {
                editor->setText(editedValue);
                edVal = editedValue;
            }

        }
    }
    editedValue = edVal;
    if (!isTreeView) {
        editor->setText(editor->text());
    }
}

void LineDocProperty::setValue( const QString  &v ) {
    QString temp = v;
    editor->blockSignals( TRUE );
    int oldCursorPos;
    oldCursorPos = editor->cursorPosition();
    int j = 0;

    if (prop->GetKind()  == PropertyValue::Property_Float) {

        const QValidator * vld = editor->validator ();
        if (!(temp[0] == '-' && temp.length() == 1 )) {
            if ( vld->validate( temp , j )  == QValidator::Intermediate) {
                double min =    ((QDoubleValidator*) vld)->bottom ();
                double max =    ((QDoubleValidator*) vld)->top ();
                if (min > 0 ) {
                    if (temp.toFloat() >= ((QDoubleValidator*) vld)->bottom () || temp.toFloat() <= 0)
                        if ( vld->validate( temp , j )  != QValidator::Intermediate) temp.remove( temp.length()-1, 1);
                }
                if (max < 0) {
                    if (temp.toFloat() <= ((QDoubleValidator*) vld)->top () || temp.toFloat() >=0)
                        if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);

                }
                if (min <= 0 && max >= 0) if ( vld->validate( temp , j )  != QValidator::Acceptable)
                        temp.remove( temp.length()-1, 1);
            }
        }
    }

    if (prop->GetKind()  == PropertyValue::Property_Int) {

        const QValidator * vld = editor->validator ();
        if (!(temp[0] == '-' && temp.length() == 1)) {
            if ( vld->validate( temp , j )  == QValidator::Intermediate) {
                int min =    ((QIntValidator*) vld)->bottom ();
                int max =    ((QIntValidator*) vld)->top ();
                if (min > 0 ) {
                    if (temp.toFloat() >= ((QIntValidator*) vld)->bottom () || temp.toFloat() <= 0)
                        if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
                }
                if (max < 0) {
                    if (temp.toFloat() <= ((QIntValidator*) vld)->top () || temp.toFloat() >=0)
                        if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);

                }
                if (min <= 0 && max >= 0) if ( vld->validate( temp , j )  != QValidator::Acceptable)
                        temp.remove( temp.length()-1, 1);
            }
        }
    }

    editor->setText(temp);
    if ( oldCursorPos < (int)editor->text().length() )
        editor->setCursorPosition( oldCursorPos );
    editor->blockSignals( FALSE );
}


//----------------------------------------------------------------------------------



