#include <QtGui>
#include "mainwindow.h"
#include <QMessageBox>
#include <stdlib.h>
#include <qwt_math.h>
#include <qwt_plot_canvas.h>
#include <qframe.h>
#include <qtooltip.h>
#include "mainwindow.h"
#include "bode_plot.h"
#include "default.h"
#include "bode.h"
#include "dataset.h"

void delBodePlotAndNullify ( BodePlot* &pBodePlot ) {delete  pBodePlot;  pBodePlot = 0;}
void delFrameAndNullify ( QFrame* &pFrame ) {delete  pFrame;  pFrame = 0;}




//----------------------------------------------------------------------------------------------------------------------------------------------
GraphWin::~GraphWin()
{

	for_each ( vBodePlot.begin(),vBodePlot.end(),delBodePlotAndNullify );
	vBodePlot.erase ( remove ( vBodePlot.begin(),vBodePlot.end(),
	                           static_cast<BodePlot* > ( 0 ) ),
	                  vBodePlot.end() );

	for_each ( vFrame.begin(),vFrame.end(),delFrameAndNullify );
	vFrame.erase ( remove ( vFrame.begin(),vFrame.end(),
	                        static_cast<QFrame* > ( 0 ) ),
	               vFrame.end() );

}
GraphWin::GraphWin ( QWidget *p ,CDataInfo* dataInfo,const char *name ) :
		QWidget ( p ),dataInfo ( dataInfo )
{
	parentWin = ( MainWin* ) p;

	numRow =2;
	numCol  =3;
	numCurve = 6;
//QMessageBox::warning(0,"","GraphWin");
	MainWindowLayout = new QGridLayout ( this );
	groupBox = new QGroupBox ( this );
	groupBoxLayout = new QGridLayout ( groupBox );
	groupBoxLayout->setAlignment ( Qt::AlignTop );



	// groupBoxLayout->addMultiCellWidget( textLabel1, 0, 0, 0, numCol -1 );


	vector<CDataSet* > dvector = dataInfo->GetDataSet();
	vector<CDataSet* >::iterator itta = dvector.begin();

	plotDuration = new DurationPlot ( groupBox, ( *itta ),dataInfo,"Plot Duration" );
	vBodePlot.push_back ( plotDuration );
	itta++;

	plotMajorAxis = new MajorAxisPlot ( groupBox,( *itta ),dataInfo,"Plot Duration" );
	vBodePlot.push_back ( plotMajorAxis );
	itta++;


	plotMinorAxis = new MinorAxisPlot ( groupBox,( *itta ),dataInfo,"Plot Duration" );
	vBodePlot.push_back ( plotMinorAxis );
	itta++;

	plotCentroid = new CentroidPlot ( groupBox, ( *itta ),dataInfo,"Plot Duration" );
	vBodePlot.push_back ( plotCentroid );
	itta++;

	plotMajorStrike = new MajorStrikePlot ( groupBox, ( *itta ),dataInfo,"Plot Duration" );
	vBodePlot.push_back ( plotMajorStrike );
	itta++;

	plotVelocityStrike = new VelocityStrikePlot ( groupBox,( *itta ),dataInfo,"Plot Duration" );
	vBodePlot.push_back ( plotVelocityStrike );
	itta++;


	vector<BodePlot* >::iterator  it = vBodePlot.begin();
	int j=0; int k=0;
	for ( j=0;j<numRow;j++ )
	{
		for ( k=0;k<numCol;k++ )
		{
			groupBoxLayout->addWidget ( ( *it ), j+1,k );
			it++;
			if ( it == vBodePlot.end() ) break;
		}
		if ( it == vBodePlot.end() ) break;
	}

	// groupBoxLayout->addMultiCellWidget( textLabel2, numRow+2, numRow+2, 0,numCol -1 );

	//    MainWindowLayout->addWidget( groupBox, 0, 0 );
	MainWindowLayout->addWidget ( groupBox,0, 0 );
	show();


}
void GraphWin::ChangeFont ( QFont f )
{
	/*
	QFont labelFont = f;
	labelFont.setPointSize(labelFont.pointSize() + 1 );
	textLabel1->setFont(labelFont);
	textLabel1->setText(textLabel1->text());

	textLabel2->setFont(labelFont);
	textLabel2->setText(textLabel2->text());

	    //AxisFont.setBold(true);
	    QwtText qtext("Depth,km");
	    qtext.setFont (AxisFont);
	    qtext.setColor (Qt::darkBlue);
	    //setAxisTitle(QwtPlot::xBottom, qtext);
	    qtext.setText(titleStr);
	    setTitle(qtext);
	*/
}

