#include <qwt_plot.h>
#include <qwt_data.h>
#include <qwt_scale_draw.h>
//Added by qt3to4:
#include <math.h>
//-----------------------------------------

//	#include <qwt_dimap.h>
	#include <qwt_plot_printfilter.h>
             #include <qwt_array.h>

//-------------------------------------------
/////////////////////////////////////////////////////////////////
class QColor;
class QwtPlotPicker;
class CDataSet;
class CDataInfo;
class QwtPlotMarker;
//------------------------------------------------------------------
class QPainter;
//------------------------------------------------------------------
class CdScaleDraw: public QwtScaleDraw {
public:
    CdScaleDraw(QColor col);
    void    draw(QPainter *, const QPalette &) const;



private:
    QColor  color;
};



class BodePlot: public QwtPlot
{
    Q_OBJECT
public:
    BodePlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~BodePlot();
 //      void drawContents(QPainter *p);
    void   printCanvas(QPainter *p, const QRect &br,const QRect &r, const QwtScaleMap m[axisCnt], const QwtPlotPrintFilter & f) const;
    void   ChangeFont(QFont& f);
private slots: 
private:
    CDataSet* data;
    CDataInfo* dataInfo;

    bool prn;
    QwtPlotMarker* mrk1, *mrk2,*mrk3,*mrk4;
    
    void showInfoDuration(QString text = QString::null);
    QwtPlotPicker *pickerDuration;
    QString titleYAxis;
};
//-----------------------------------------------------------------------------------------------------------------------------
class DurationPlot: public BodePlot
{
    Q_OBJECT
public:
    DurationPlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~DurationPlot();
   
private:
  
};
//-----------------------------------------------------------------------------------------------------------------------------
class MajorAxisPlot: public BodePlot
{
    Q_OBJECT
public:
    MajorAxisPlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~MajorAxisPlot();
   
private:
  
};
//-----------------------------------------------------------------------------------------------------------------------------
class MinorAxisPlot: public BodePlot
{
    Q_OBJECT
public:
    MinorAxisPlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~MinorAxisPlot();
   
private:
  
};
//-----------------------------------------------------------------------------------------------------------------------------
class CentroidPlot: public BodePlot
{
    Q_OBJECT
public:
    CentroidPlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~CentroidPlot();
   
private:
  
};
//-----------------------------------------------------------------------------------------------------------------------------
class MajorStrikePlot: public BodePlot
{
    Q_OBJECT
public:
    MajorStrikePlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~MajorStrikePlot();
   
private:
  
};
//-----------------------------------------------------------------------------------------------------------------------------
class VelocityStrikePlot: public BodePlot
{
    Q_OBJECT
public:
    VelocityStrikePlot(QWidget *parent,CDataSet* data,CDataInfo* dataInfo,QString name,bool prn = false);

    virtual     ~VelocityStrikePlot();
   
private:
  
};
