#include <qdir.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qmessagebox.h>
#include "dataset.h"
#include "default.h"
#include <float.h>



//--------------------------------------- CDataInfo  --------------------------------------------------------------------------------------------------------------------------------------
void delDataSetAndNullify ( CDataSet* &pCDataSet ) {delete  pCDataSet;  pCDataSet = 0;}
CDataInfo::~CDataInfo()
{
	for_each ( DataSet.begin(),DataSet.end(),delDataSetAndNullify );
	DataSet.erase ( remove ( DataSet.begin(),DataSet.end(),
	                         static_cast<CDataSet*> ( 0 ) ),
	                DataSet.end() );
}
CDataInfo::CDataInfo ( const QString &nameDir ) :
		PlaceDirectory ( nameDir )
{

	QDir dirTemp ( nameDir );
	QStringList list = dirTemp.entryList();
	QStringList fields = momentTensorLocatorFileName().split ( ' ', QString::SkipEmptyParts );

	for ( QStringList::Iterator itf = fields.begin(); itf != fields.end(); ++itf )
		for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )
		{
			QString fn = ( *it ).toLower ();
			if ( fn == ( *itf ) )
			{
				QString lfile =   nameDir + QDir::convertSeparators ( "/" )  + ( *it );

				CDataSet *dataSet = new CDataSet ( lfile );
				DataSet.push_back ( dataSet );

			}
		}

}

void CDataInfo::PrintDataInfo()
{
	/*
	    qWarning("Print info data to plot:");
	    qWarning("projectOpenName: '%s'", projectOpenName.ascii());
	    qWarning("PlaceDirectory: '%s'", PlaceDirectory.ascii());
	    qWarning("Data Det:> ");
	    DataSetVectorIterator it;
	    int j = 0;
	    for ( it = DataSet.begin(); it !=DataSet.end(); ++it ) {

		j++;
		vector<CDoubleData* > dvector =  (*it)->GetDoubleData();
		int i = 0;
		for ( vector<CDoubleData* >::iterator itt = dvector.begin(); itt != dvector.end(); ++itt){
		    qWarning("       curve:%d : '%s'  ",i+1,(*itt)->GetFileName().ascii());
		    i++;
		}


	    }
	*/
}

//--------------------------------------- CDataSet --------------------------------------------------------------------------------------------------------------------------------------

void delDoubleDataAndNullify ( CDoubleData* &pCDoubleData ) {delete  pCDoubleData;  pCDoubleData = 0;}
CDataSet::~CDataSet()
{

	for_each ( DoubleData.begin(),DoubleData.end(),delDoubleDataAndNullify );
	DoubleData.erase ( remove ( DoubleData.begin(),DoubleData.end(),
	                            static_cast<CDoubleData*> ( 0 ) ),
	                   DoubleData.end() );
}

CDataSet::CDataSet ( const QString fileName )
{

	CDoubleData *ddata = new CDoubleData ( fileName );
	DoubleData.push_back ( ddata );



}
//--------------------------------------- CDoubleData --------------------------------------------------------------------------------------------------------------------------------------
CDoubleData::~CDoubleData()
{
	if ( X != 0 ) {delete [] X; X = 0;}
	if ( Y != 0 ) {delete [] Y; Y = 0;}
}
CDoubleData::CDoubleData ( const QString &fileName ) : FileName ( fileName ),X ( 0 ),Y ( 0 )
{

	QStringList lines;
	QFile fd ( fileName );
	Size = 0;
	if ( fd.open ( QIODevice::ReadOnly ) )
	{
		QTextStream stream ( &fd );
		QString line;

		do
		{
			line = stream.readLine();
			QStringList lst = line.split ( ' ', QString::SkipEmptyParts );
			if ( lst.size() < 2 ) break;
			lines << line;
		}
		while ( !line.isNull() );

		fd.close();
		int sizeList = ( int ) lines.size ();
		X = new double[sizeList];
		Y = new double[sizeList];

		for ( int j = 0; j < lines.size(); ++j )
		{
			//   sscanf(lines.at(j).toAscii(),"%le%le",&X[i],&Y[i]);

			QStringList lst = lines.at ( j ).split ( ' ', QString::SkipEmptyParts );
			X[j] = lst.at ( 0 ).toFloat();
			Y[j] = lst.at ( 1 ).toFloat();

		}
		Size = sizeList;

	}
	else
	{

		QMessageBox::warning ( 0,mainWindowCaption(),QString ( "Get data for plot::> Can't open flle for reading\n%1" ).arg ( fileName ) );

	}
	if ( Size > 0 )
	{
		MinX = MinY = DBL_MAX;
		MaxX = MaxY = -DBL_MAX;
		for ( int i = 0;i < Size;++i )
		{
			if ( X[i] <MinX ) MinX = X[i];
			if ( Y[i] <MinY ) MinY = Y[i];
			if ( X[i] >MaxX ) MaxX = X[i];
			if ( Y[i] >MaxY ) MaxY = Y[i];
		}

	}

}
