#ifndef  PLOT_DATA_SET_H
#define PLOT_DATA_SET_H
#include <qstring.h> 
#include <qstringlist.h>
#include <vector>
#include <set>
#include <functional>
#include <algorithm>

using namespace std;

class CDoubleData
{
public:
    CDoubleData(){}
    CDoubleData(const QString &fileName);
    ~CDoubleData();    
    QString &GetFileName(){return FileName;}
    double* &GetX(){return X;}
    double* &GetY(){return Y;}
    double &GetMinX(){return MinX;}
    double &GetMaxX(){return MaxX;}    
    double &GetMinY(){return MinY;}    
    double &GetMaxY(){return MaxY;}
    int         &GetSize() { return Size;}
private:
    QString FileName;
    int Size;
    double* X;
    double* Y;
    double MinX;
    double MaxX;    
    double MinY;    
    double MaxY;
};
class CDataSet
{
    typedef vector<CDoubleData* > DataVector;
    typedef vector<CDoubleData* >::iterator DataVectorIterator;    
public:
    CDataSet(){}
    CDataSet(const QString fileName );
    ~CDataSet();
   
   DataVector &GetDoubleData(){ return DoubleData;}
private:
  
    DataVector DoubleData;    
};
class CDataInfo
{
    typedef vector<CDataSet* > DataSetVector;
    typedef vector<CDataSet* >::iterator DataSetVectorIterator;    
public:
    CDataInfo(){}
    CDataInfo(const QString &nameDir);
    ~CDataInfo(); 
    void PrintDataInfo();

    

    
    QString &GetPlaceDirectory(){ return PlaceDirectory;}
  
    
    DataSetVector &GetDataSet(){ return DataSet;}     

private:
    QString PlaceDirectory;
    
    DataSetVector DataSet;    
};
#endif
