#!/bin/csh -f

#fpol.com <ps_file> <pol_file1> [<pol_file2>]

set ps_file = $1

set pol_file = " "
set ntitle = " "
@ i = 1
while($i < $#argv)
    @ i++
    set pol_file = "$pol_file $argv[$i] "
    set t = `awk 'BEGIN{t=0}{if(substr($0,1,1)=="t") t=t+1;}END{print t}' $argv[$i]`
    set ntitle = "$ntitle $t "
end
set pol_file = `echo $pol_file`
set ntitle = `echo $ntitle`

set radius2 = 3.0
set radius = `(echo scale=2;echo $radius2/2.)|bc`
set xoffset0 = 4.1
set yoffset0 = 10.5

gmtset ANOT_FONT_SIZE 10 COLOR_NAN 255/255/255 MEASURE_UNIT inch DOTS_PR_INCH 300
echo 0 0 0 | psxy -R-1/1/-1/1 -Jx1 -P -K -X$xoffset0 -Y$yoffset0 > $ps_file

@ i = 0
foreach file ($pol_file)
    @ i++
    @ j = 0
    @ t = $ntitle[$i] + 1
    while ($j < $ntitle[$i])
        @ j++
        set title = `head -$j $file |tail -1|cut -c2-120`
        pstext -R0/1/0/1 -Jx1 -P -N -O -K << enddata >> $ps_file
0 `echo "-($i-1)*$radius-0.4*$j"|bc` 14 0 1 2 `echo "$title"`
enddata
    end
    set yoffset = `echo $radius\*$i+0.4+0.4\*$ntitle[$i]|bc`
    awk '{if(substr($7,3,1) == "u") print $0;}' $file | \
        psprojstations -R -Jx -A$radius -D0/0 -G0/0/255 -Sc0.1 -W2/0/0/255 -s1 -L -N -P -K -O -Y-$yoffset >> $ps_file
    awk '{if(substr($7,3,1) == "d") print $0;}' $file | \
        psprojstations -R -Jx -A$radius -D0/0 -G0/0/255 -Sc0.1 -W2/0/0/255 -s1 -L -N -P -K -O >> $ps_file
end

 
ghostview -forcemedia -a4 $ps_file 
