#!/bin/csh -f

set cpt_file = $1
set ps_file = $2

set data_file = " "
set ntitle = " "
@ i = 2
while($i < $#argv)
    @ i++
    set data_file = "$data_file $argv[$i] "
    set t = `awk 'BEGIN{t=0}{if(substr($0,1,1)=="t") t=t+1;}END{print t}' $argv[$i]`
    set ntitle = "$ntitle $t "
end
set data_file = `echo $data_file`
set ntitle = `echo $ntitle`

set radius2 = 3.0
set proj = (-JA0/-89.9/$radius2 -P)
set frame = -R-180/180/-90/90
set radius = `(echo scale=2;echo $radius2/2.)|bc`
set xoffset0 = `echo 4.1-$radius|bc`
set yoffset0 = 10.5

gmtset ANOT_FONT_SIZE 10 COLOR_NAN 255/255/255 MEASURE_UNIT inch DOTS_PR_INCH 300
echo 0 0 0 | psxy -R-1/1/-1/1 -Jx1 -P -K -X$xoffset0 -Y$yoffset0 > $ps_file

@ i = 0
foreach file ($data_file)
    @ i++
    @ j = 0
    @ t = $ntitle[$i]
    while ($j < $t)
        @ j++
        set title = `head -$j $data_file[$i]|tail -1|cut -c2-120`
        pstext -R0/1/0/1 -Jx1 -P -N -O -K << enddata >> $ps_file
`echo $radius` `echo -0.4\*$j|bc` 14 0 1 2 `echo "$title"`
enddata
    end
    xyz2grd $file -: -H$ntitle[$i] -Ggrdfile -I7d/7d $frame -V
    set yoffset = `echo $radius2+0.4+0.4\*$ntitle[$i]|bc`
    grdimage grdfile -C$cpt_file -V  $frame $proj -K -B30g30 -Y-$yoffset -O >> $ps_file  
end

psscale -C$cpt_file -P -X$radius -D0/-0.6/4.5/0.2/h -O -L >> $ps_file

ghostview -forcemedia -a4 -magstep -1 $ps_file 
