#!/bin/csh -f 

set mech_file = $1
set ps_file = $2

@ nl = `cat $mech_file | wc -l`
@ ntitle = `awk 'BEGIN{t=0}{if(substr($0,1,1)=="t") t=t+1;}END{print t}' $mech_file`
@ nd = $nl - $ntitle
@ npage = $nd / 8
@ nleft = $nd % 8

set yoffset0 = 0.
set xoffset0 = 0.
set hw = 4.1
set h = 10.5
gmtset HEADER_FONT_SIZE 24 MEASURE_UNIT inch DOTS_PR_INCH 300
echo 0 0 0 | psxy -R-1/1/-1/1 -Jx1 -P -K -X$xoffset0 -Y$yoffset0 > $ps_file

@ it = 0
while ($it < $ntitle)
    @ it++
    set title = `head -$it $mech_file | tail -1|cut -c2-120`
    pstext -R0/1/0/1 -Jx1 -P -N -O -K << enddata >> $ps_file
`echo $hw`  `echo $h-0.4\*$it|bc` 14 0 1 2 `echo "$title"`
enddata
end    

switch ($npage)
    case 0:
        tail -$nleft $mech_file | \
            psmeca -A0.015/0.0/3/0/2/9/0.2 -Q0.1ccS -R0/20/0/20 -Jx1 -G0/0/255 \
            -I240/255/255 -L -g0 -Sa1. -N -P -O -X0 -Y0 -W1/0/0/255 >> $ps_file
        breaksw
    default:
        @ ip = 0
        while ($ip < $npage)
            @ ip++
            @ id = $ip * 8 + $ntitle
            if($ip == 1) then
                set over = "-O"
            else
                set over = " "
            endif
            head -$id $mech_file | tail -8 | \
                psmeca -A0.015/0.0/3/0/2/9/0.2 -Q0.1ccS -R0/20/0/20 -Jx1 -G0/0/255  \
                -I240/255/255 -L -g0 -Sa1. -N -P $over -X0 -Y0 -W1/0/0/255 >> $ps_file
        end

        if($nleft) then
            tail -$nleft $mech_file | \
                psmeca -A0.015/0.0/3/0/2/9/0.2 -Q0.1ccS -R0/20/0/20 -Jx1 -G0/0/255 \
                -I240/255/255 -L -W1/0/0/255 -g0 -Sa1. -N -P -X0 -Y0 >> $ps_file
        endif
        breaksw
endsw
ghostview -forcemedia -a4 $ps_file 
